/*ROTH Map Editor

                   Cod par Gradapin (ou Grade)*/


#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>

#include "constantes.h"
#include "savload.h"

void verserLePot(int objet, int ancienObjet, int x, int y, int xPrincipal, int yPrincipal, int couche, short **carte, short **mur, short **air, int nbPixelX, int nbPixelY, int nbFois);

int main(int argc, char *argv[])
{
    SDL_Surface *ecran=NULL, *image=NULL, *images[2]={NULL}, *image2=NULL, *collisions[14]={NULL}, *teste=NULL, *texte=NULL, *entreContenu=NULL, *surfaceChiffres[4]={NULL}, *barreOutil=NULL, *fondNoir=NULL, *caase=NULL, *caseCochee=NULL, *barreBas=NULL, *entreTransparence=NULL, *surfaceAncien=NULL, *afficheMotif1=NULL, *afficheMotif2=NULL, *selectMotif=NULL, *imagesOlb[5]={NULL}, *imagesMotifsOlb[5]={NULL}, *entrerLargeur=NULL, *entrerHauteur=NULL, *impossibleChargerCarte=NULL, *vide=NULL, *impossibleChargerObjet=NULL, *otherBarreOutil=NULL, *entrerLargeurObjet=NULL, *entrerHauteurObjet=NULL, *blocNoir=NULL, *confirmation=NULL, *grandcarre=NULL, *petitcarre=NULL, *imgToolTips[18]={NULL};
    SDL_Rect position, clip, whenClic, positionImages, testObjet, positionCadre={-100}, souris2;
    SDL_Event event;
    SDL_Color couleur={0,0,0}, couleur2={200,200,200};
    int continuer=1, i=0, j=0, nbPixelX=0, nbPixelY=0, scrolling=0, scrollingVertical=0, val=0, x=0, y=0, mapActuelle=1, nbMotifsAeriens=0, nbContenu=0, objetActuel=0, boolMaj=0, boolCapsLock=0, couche=0, collisionActuel=1, clicDroit=0, clicGauche=0, boolContenu=0, lettreActuel=0, longueurLettre=0, xSouris=0, ySouris=0, boolContenu2=0, boolCochee=0, boolTest=0, boolEntreTransparence=0, transparence=128, boolInterdiction=0, boolImages=0, imagesMotifs=0, versions=0, nbMaps=0, boolEntrerLargeur=0, boolEntrerHauteur=0, largeur=0, hauteur=0, boolObjets=0, objet=0, boolImpossibleChargerCarte=0, boolImpossibleChargerObjet=0, objectActuel=1, nbMotifsObjet=0, nbCollisionsObjet=0, nbMotifsAeriensObjet=0, nbContenuObjet=0, nbPixelXObjet=0, nbPixelYObjet=0, nbObjets=0, objetEnCours=1, whenCouche=0, positionVLPx=0, positionVLPy=0, boolCatalogue=0, xObjet=0, yObjet=0, boolOk=0, objetACharger=1, boolReSizeMap=0, page=1, nbPages=100, boolFullScreen=0, boolConfirmation=0, boolCtrl=0, nbMotifs=0, nbCollisions=0, tooltips=0;
    char positionSouris[50]="";
    char numContenu[4]="";
    char ancien[15]="";
    char nomMap[14]="";
    char nomObjet[20]="";
    char ecrireChar[10]="";
    char ecrireChar2[10]="";
    FILE *testFichier=NULL, *nouvelleMap=NULL;
    /*int carte[BLOCS_LARGEUR][BLOCS_HAUTEUR]={0};
    int mur[BLOCS_LARGEUR*2][BLOCS_HAUTEUR*2]={0};
    int air[BLOCS_LARGEUR][BLOCS_HAUTEUR]={0};
    int contenu[200][200]={0};*/
    short **carte=NULL, **mur=NULL, **air=NULL, **contenu=NULL, **carteObjet=NULL, **murObjet=NULL, **airObjet=NULL, **contenuObjet=NULL, **undoMatrice=NULL, **carteCatalogue=NULL, **airCatalogue=NULL;
    /*short carte[350][350]={0};
    short mur[700][700]={0};
    short air[350][350]={0};
    short contenu[350][350]={0};*/
    int boolCaseCataPrise[40][30]={0};
    int boolExploree[40][30]={0};
    int indicePremierePage[100]={0};
    indicePremierePage[1]=1;
    carte=malloc(400*sizeof(int));
    mur=malloc(800*sizeof(int));
    air=malloc(400*sizeof(int));
    contenu=malloc(400*sizeof(int));
    carteObjet=malloc(400*sizeof(int));
    murObjet=malloc(800*sizeof(int));
    airObjet=malloc(400*sizeof(int));
    contenuObjet=malloc(400*sizeof(int));
    undoMatrice=malloc(800*sizeof(int));
    carteCatalogue=malloc(41*sizeof(int));
    airCatalogue=malloc(41*sizeof(int));
    for (i = 0; i < 400; i++)
        carte[i] = malloc(400 * sizeof( short));
    for (i = 0; i < 800; i++)
        mur[i] = malloc(800 * sizeof( short));
    for (i = 0; i < 400; i++)
        air[i] = malloc(400 * sizeof( short));
    for (i = 0; i < 400; i++)
        contenu[i] = malloc(400 * sizeof( short));
    for (i = 0; i < 400; i++)
        carteObjet[i] = malloc(400 * sizeof( short));
    for (i = 0; i < 800; i++)
        murObjet[i] = malloc(800 * sizeof( short));
    for (i = 0; i < 400; i++)
        airObjet[i] = malloc(400 * sizeof( short));
    for (i = 0; i < 400; i++)
        contenuObjet[i] = malloc(400 * sizeof( short));
    for (i = 0; i < 800; i++)
        undoMatrice[i] = malloc(800 * sizeof( short));
    for (i = 0; i < 41; i++)
        carteCatalogue[i] = malloc(41 * sizeof( short));
    for (i = 0; i < 41 ; i++)
        airCatalogue[i] = malloc(41 * sizeof( short));

    for (i=0 ; i<400 ; i++)
    {
        for (j=0 ; j<400 ; j++)
        {
            carte[i][j]=0;
            air[i][j]=0;
            contenu[i][j]=0;
            carteObjet[i][j]=-1;
            airObjet[i][j]=-1;
            contenuObjet[i][j]=-1;
        }
    }
    for (i=0 ; i<800 ; i++)
    {
        for (j=0 ; j<800 ; j++)
        {
            mur[i][j]=0;
            murObjet[i][j]=0;
            undoMatrice[i][j]=0;
        }
    }
    SDL_Init(SDL_INIT_VIDEO);
    TTF_Init();
    TTF_Font *police=TTF_OpenFont("arial.ttf", 20);
    TTF_Font *police2=TTF_OpenFont("arial.ttf", 8);
    ecran=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE);
    SDL_WM_SetCaption("Editeur de map pour Zelda ROTH", NULL);

    int phg[2]={0}; //Merci Vincent pour le phg (Point en Haut  Gauche)
    int ancienPhg[2]={0};
    int ancienPhg2[2]={0};
    int phgx[1000]={0};
    int phgy[1000]={0};

    position.x=0;
    position.y=0;
    positionImages.x=0;
    positionImages.y=0;

    images[0]=IMG_Load("Images/image1.png");
    images[1]=IMG_Load("Images/image2.png");
    imagesOlb[0]=IMG_Load("Images/image3.png");
    imagesOlb[1]=IMG_Load("Images/image4.png");
    imagesOlb[2]=IMG_Load("Images/image5.png");
    imagesOlb[3]=IMG_Load("Images/image6.png");
    imagesOlb[4]=IMG_Load("Images/image7.png");
    imagesMotifsOlb[0]=IMG_Load("Images/image3.png");
    imagesMotifsOlb[1]=IMG_Load("Images/image4.png");
    imagesMotifsOlb[2]=IMG_Load("Images/image5.png");
    imagesMotifsOlb[3]=IMG_Load("Images/image6.png");
    imagesMotifsOlb[4]=IMG_Load("Images/image7.png");
    //for (i=0 ; i<5 ; i++) imagesMotifsOlb[i]=imagesOlb[i];
    afficheMotif1=IMG_Load("Images/image1.png");
    afficheMotif2=IMG_Load("Images/image2.png");
    collisions[0]=IMG_Load("Images/collision1.png");
    collisions[1]=IMG_Load("Images/collision2.png");
    collisions[2]=IMG_Load("Images/collision3.png");
    collisions[3]=IMG_Load("Images/collision4.png");
    collisions[4]=IMG_Load("Images/collision5.png");
    collisions[5]=IMG_Load("Images/collision6.png");
    collisions[6]=IMG_Load("Images/collision7.png");
    collisions[7]=IMG_Load("Images/collision8.png");
    collisions[8]=IMG_Load("Images/collision9.png");
    collisions[9]=IMG_Load("Images/collision10.png");
    collisions[10]=IMG_Load("Images/collision11.png");
    collisions[11]=IMG_Load("Images/collision12.png");
    collisions[12]=IMG_Load("Images/collision13.png");
    collisions[13]=IMG_Load("Images/collision14.png");
    teste=IMG_Load("Images/test.png");
    entreContenu=IMG_Load("Images/entreContenu.png");
    barreOutil=IMG_Load("Images/barre outil.png");
    caase=IMG_Load("Images/case.png");
    caseCochee=IMG_Load("Images/case coche.png");
    barreBas=IMG_Load("Images/barre bas.png");
    entreTransparence=IMG_Load("Images/entreTransparence.png");
    selectMotif=IMG_Load("Images/carr.png");
    entrerLargeur=IMG_Load("Images/entrerLargeur.png");
    entrerHauteur=IMG_Load("Images/entrerHauteur.png");
    impossibleChargerCarte=IMG_Load("Images/impossible de charger.png");
    vide=IMG_Load("Images/vide.png");
    impossibleChargerObjet=IMG_Load("Images/impossible de charger objet.png");
    otherBarreOutil=IMG_Load("Images/autre barre.png");
    entrerLargeurObjet=IMG_Load("Images/entrerLargeurObjet.png");
    entrerHauteurObjet=IMG_Load("Images/entrerHauteurObjet.png");
    confirmation=IMG_Load("Images/confirmation.png");
    grandcarre=IMG_Load("Images/grand carr.png");
    petitcarre=IMG_Load("Images/petitcarre.png");
    imgToolTips[0]=IMG_Load("Images/tooltips1.png");
    imgToolTips[1]=IMG_Load("Images/tooltips2.png");
    imgToolTips[2]=IMG_Load("Images/tooltips3.png");
    imgToolTips[3]=IMG_Load("Images/tooltips4.png");
    imgToolTips[4]=IMG_Load("Images/tooltips5.png");
    imgToolTips[5]=IMG_Load("Images/tooltips6.png");
    imgToolTips[6]=IMG_Load("Images/tooltips7.png");
    imgToolTips[7]=IMG_Load("Images/tooltips8.png");
    imgToolTips[8]=IMG_Load("Images/tooltips9.png");
    imgToolTips[9]=IMG_Load("Images/tooltips10.png");
    imgToolTips[10]=IMG_Load("Images/tooltips11.png");
    imgToolTips[11]=IMG_Load("Images/tooltips12.png");
    imgToolTips[12]=IMG_Load("Images/tooltips13.png");
    imgToolTips[13]=IMG_Load("Images/tooltips14.png");
    imgToolTips[14]=IMG_Load("Images/tooltips15.png");
    imgToolTips[15]=IMG_Load("Images/tooltips16.png");
    imgToolTips[16]=IMG_Load("Images/tooltips17.png");
    imgToolTips[17]=IMG_Load("Images/tooltips18.png");
    blocNoir=SDL_CreateRGBSurface(SDL_HWSURFACE, 16, 16, 32, 0, 0, 0, 0);
    fondNoir=SDL_CreateRGBSurface(SDL_HWSURFACE, 640, 480, 32, 0, 0, 0, 0);
    SDL_SetAlpha(fondNoir, SDL_SRCALPHA, transparence);
    for (i=0 ; i<14 ; i++)
        SDL_SetColorKey(collisions[i], SDL_SRCCOLORKEY, SDL_MapRGB(collisions[i]->format, 0,0,0));
    SDL_SetColorKey(teste, SDL_SRCCOLORKEY, SDL_MapRGB(teste->format, 0,0,0));
    SDL_SetColorKey(selectMotif, SDL_SRCCOLORKEY, SDL_MapRGB(selectMotif->format, 0,0,0));
    SDL_SetColorKey(grandcarre, SDL_SRCCOLORKEY, SDL_MapRGB(grandcarre->format, 0,0,0));
    SDL_SetColorKey(petitcarre, SDL_SRCCOLORKEY, SDL_MapRGB(petitcarre->format, 0,0,0));
    for (i=1 ; i<=1000 ; i++)
    {
        sprintf(nomMap, "map/carte%ld.map", i);
        testFichier=fopen(nomMap, "r");
        if (testFichier!=NULL) nbMaps++, fclose(testFichier);;
    }
    for (i=1 ; i<=1000 ; i++)
    {
        sprintf(nomObjet, "object/objet%ld.obj", i);
        testFichier=fopen(nomObjet, "r");
        if (testFichier!=NULL) nbObjets++, fclose(testFichier);;
    }

    if (!loadMap(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifsAeriens, &nbContenu, mapActuelle))
        boolImpossibleChargerCarte=1, fprintf(stderr, "Impossible de charger map/carte%ld.map !\n", mapActuelle);
    for (i=0 ; i<400 ; i++)
    {
        for (j=0 ; j<400 ; j++)
        {
            undoMatrice[i][j]=carte[i][j];
        }
    }

    /*for (i=0 ; i<BLOCS_HAUTEUR ; i++)
    {
        for (j= 0 ; j<BLOCS_LARGEUR ; j++)
        {
            fprintf(stderr, "%ld\n", carte[0][j][i]);
        }
    }*/
    //fprintf(stderr, "nbPixelX=%ld nbPixelY=%ld\n", nbPixelX, nbPixelY);

    SDL_EnableKeyRepeat(100,100);
    while(continuer)
    {
        SDL_WaitEvent(&event);
        switch(event.type)
        {
            case SDL_QUIT:
                continuer=0;
                break;
            case SDL_KEYDOWN:
                switch(event.key.keysym.sym)
                {
                    /*case SDLK_CAPSLOCK:
                        if (boolCapsLock==0)
                            boolCapsLock=1, boolMaj=1;
                        else
                            boolCapsLock=0, boolMaj=0;
                        fprintf(stderr, "boolMaj=%ld boolCapsLock=%ld\n", boolMaj, boolCapsLock);
                        break;*/
                    case SDLK_LCTRL : case SDLK_RCTRL :
                        boolCtrl=1;
                        break;
                    case SDLK_LSHIFT : case SDLK_RSHIFT :
                        boolMaj=1;
                        break;
                    case SDLK_RIGHT:
                        if (!boolContenu && !boolInterdiction)
                        {
                            if (boolCtrl==1 && !boolObjets)
                            {
                                if (phg[0]+(16+640)<=nbPixelX)
                                    phg[0]+=16;
                            }
                            else
                            {
                                if (couche==0 || couche==2)
                                    objetActuel++;
                                else if (couche==5)
                                {
                                    if (objetEnCours!=nbObjets)
                                    {
                                        objetEnCours++;
                                        if (!boolObjets)
                                        {
                                            for (i=0 ; i<400 ; i++)
                                            {
                                                for (j=0 ; j<400 ; j++)
                                                {
                                                    carteObjet[i][j]=-1;
                                                    airObjet[i][j]=0;
                                                    contenuObjet[i][j]=0;
                                                }
                                            }
                                            for (i=0 ; i<800 ; i++)
                                            {
                                                for (j=0 ; j<800 ; j++)
                                                {
                                                    murObjet[i][j]=0;
                                                }
                                            }
                                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objetEnCours))
                                                exit(EXIT_FAILURE);
                                        }
                                        else if (boolObjets)
                                        {
                                            for (i=0 ; i<400 ; i++)
                                            {
                                                for (j=0 ; j<400 ; j++)
                                                {
                                                    carte[i][j]=-1;
                                                    air[i][j]=0;
                                                    contenu[i][j]=0;
                                                }
                                            }
                                            for (i=0 ; i<800 ; i++)
                                            {
                                                for (j=0 ; j<800 ; j++)
                                                {
                                                    mur[i][j]=0;
                                                }
                                            }
                                            if (!loadObject(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifs, &nbCollisions, &nbMotifsAeriens, &nbContenu, objetEnCours))
                                                exit(EXIT_FAILURE);
                                        }
                                    }
                                }
                                else if (couche==1)
                                {
                                    if (collisionActuel==-1)
                                        collisionActuel=1;
                                    else if (collisionActuel!=13)
                                        collisionActuel++;
                                }
                            }
                        }
                        else if (boolCatalogue)
                        {
                            if (indicePremierePage[page+1]==0) nbPages=page;
                            if (page<nbPages) page++;
                            for (i=0 ; i<40 ; i++)
                            {
                                for (j=0 ; j<30 ; j++)
                                {
                                    carteCatalogue[i][j]=-1;
                                    airCatalogue[i][j]=-1;
                                    boolCaseCataPrise[i][j]=0;
                                    boolExploree[i][j]=0;
                                }
                            }
                            for (objetACharger=indicePremierePage[page] ; objetACharger<=nbObjets ; objetACharger++)
                            {
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carteObjet[i][j]=-1;
                                        airObjet[i][j]=0;
                                        contenuObjet[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        murObjet[i][j]=0;
                                    }
                                }
                                testObjet.x=0, testObjet.y=0;
                                if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriens, &nbContenuObjet, objetACharger))
                                    exit(EXIT_FAILURE);

                                i=0, j=0;

                                while (j<30)
                                {
                                    if (xObjet==0 && yObjet==0 && boolCaseCataPrise[i][j]==0)
                                    {
                                        testObjet.x=i;
                                        testObjet.y=j;
                                        boolOk=0;
                                        xObjet++;
                                        i++;
                                        if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                        if (i>=40)
                                        {
                                            xObjet=0, yObjet=0;
                                            i=testObjet.x;
                                            j=testObjet.y;
                                            i++;
                                            boolExploree[testObjet.x][testObjet.y]=1;
                                            if (i>=40) i=0, j++;
                                            testObjet.x=i;
                                            testObjet.y=j;
                                        }
                                    }
                                    else if (boolCaseCataPrise[i][j]!=0)
                                    {
                                        xObjet=0, yObjet=0;
                                        i=testObjet.x;
                                        j=testObjet.y;
                                        i++;
                                        boolExploree[testObjet.x][testObjet.y]=1;
                                        if (i>=40) i=0, j++;
                                        testObjet.x=i;
                                        testObjet.y=j;
                                    }
                                    else if (boolCaseCataPrise[i][j]==0)
                                    {
                                        if (boolOk==0)
                                        {
                                            xObjet++;
                                            i++;
                                            if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                            if (xObjet==nbPixelXObjet/16 && yObjet==nbPixelYObjet/16) j=30;
                                            if (i>=40)
                                            {
                                                xObjet=0, yObjet=0;
                                                i=testObjet.x;
                                                j=testObjet.y;
                                                i++;
                                                boolExploree[testObjet.x][testObjet.y]=1;
                                                if (i>=40) i=0, j++;
                                                testObjet.x=i;
                                                testObjet.y=j;
                                            }
                                        }
                                    }
                                }
                                if (j<=testObjet.y+nbPixelYObjet/16)
                                {
                                    for (i=0 ; i<40 ; i++)
                                    {
                                        for (j=0 ; j<30 ; j++)
                                        {
                                            boolExploree[i][j]=1;
                                        }
                                    }
                                }
                                boolOk=1;
                                for (i=0 ; i<40 ; i++)
                                {
                                    for (j=0 ; j<30 ; j++)
                                    {
                                        if (boolExploree[i][j])
                                            boolExploree[i][j]=0;
                                        else
                                            boolOk=0;
                                    }
                                }
                                xObjet=0, yObjet=0;
                                if (boolOk)
                                    indicePremierePage[page+1]=objetACharger, objetACharger=nbObjets;
                                else
                                {
                                    for (i=testObjet.y ; i<nbPixelYObjet/16+testObjet.y ; i++)
                                    {
                                        for (j=testObjet.x ; j<nbPixelXObjet/16+testObjet.x ; j++)
                                        {
                                            carteCatalogue[j][i]=carteObjet[xObjet][yObjet];
                                            airCatalogue[j][i]=airObjet[xObjet][yObjet];
                                            xObjet++;
                                            if (xObjet>=nbPixelXObjet/16) xObjet=0, yObjet++;
                                            boolCaseCataPrise[j][i]=objetACharger;
                                        }
                                    }
                                }
                                xObjet=0, yObjet=0;
                            }
                            if (indicePremierePage[page+1]==0) nbPages=page;
                        }
                        if (boolImages && imagesMotifs!=1 && versions==0)
                            imagesMotifs=1, positionImages.y=0;
                        else if (boolImages && imagesMotifs!=4 && versions==1)
                            imagesMotifs++, positionImages.y=0;
                        break;
                    case SDLK_LEFT:
                        if (!boolContenu && !boolInterdiction)
                        {
                            if (boolCtrl==1 && !boolObjets)
                            {
                                if (phg[0]-16>=0)
                                    phg[0]-=16;
                            }
                            else
                            {
                                if (couche==0 || couche==2)
                                {
                                    if (!boolObjets || couche!=0 && boolObjets)
                                    {
                                        if (objetActuel!=0)
                                            objetActuel--;
                                    }
                                    else if (boolObjets)
                                    {
                                        if (objetActuel!=-1 && couche==0)
                                            objetActuel--;
                                    }
                                }
                                else if (couche==5)
                                {
                                    if (objetEnCours!=1)
                                    {
                                        objetEnCours--;
                                        if (!boolObjets)
                                        {
                                            for (i=0 ; i<400 ; i++)
                                            {
                                                for (j=0 ; j<400 ; j++)
                                                {
                                                    carteObjet[i][j]=-1;
                                                    airObjet[i][j]=0;
                                                    contenuObjet[i][j]=0;
                                                }
                                            }
                                            for (i=0 ; i<800 ; i++)
                                            {
                                                for (j=0 ; j<800 ; j++)
                                                {
                                                    murObjet[i][j]=0;
                                                }
                                            }
                                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objetEnCours))
                                                exit(EXIT_FAILURE);
                                        }
                                        else if (boolObjets)
                                        {
                                            for (i=0 ; i<400 ; i++)
                                            {
                                                for (j=0 ; j<400 ; j++)
                                                {
                                                    carte[i][j]=-1;
                                                    air[i][j]=0;
                                                    contenu[i][j]=0;
                                                }
                                            }
                                            for (i=0 ; i<800 ; i++)
                                            {
                                                for (j=0 ; j<800 ; j++)
                                                {
                                                    mur[i][j]=0;
                                                }
                                            }
                                            if (!loadObject(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifs, &nbCollisions, &nbMotifsAeriens, &nbContenu, objetEnCours))
                                                exit(EXIT_FAILURE);
                                        }
                                    }
                                }
                                else if (couche==1)
                                {
                                    if (collisionActuel==1)
                                        collisionActuel=-1;
                                    else if (collisionActuel!=-1)
                                        collisionActuel--;
                                }
                            }
                        }
                        else if (boolCatalogue)
                        {
                            if (page!=1) page--;
                            for (i=0 ; i<40 ; i++)
                            {
                                for (j=0 ; j<30 ; j++)
                                {
                                    carteCatalogue[i][j]=-1;
                                    airCatalogue[i][j]=-1;
                                    boolCaseCataPrise[i][j]=0;
                                    boolExploree[i][j]=0;
                                }
                            }
                            for (objetACharger=indicePremierePage[page] ; objetACharger<=nbObjets ; objetACharger++)
                            {
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carteObjet[i][j]=-1;
                                        airObjet[i][j]=0;
                                        contenuObjet[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        murObjet[i][j]=0;
                                    }
                                }
                                testObjet.x=0, testObjet.y=0;
                                if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriens, &nbContenuObjet, objetACharger))
                                    exit(EXIT_FAILURE);

                                i=0, j=0;

                                while (j<30)
                                {
                                    if (xObjet==0 && yObjet==0 && boolCaseCataPrise[i][j]==0)
                                    {
                                        testObjet.x=i;
                                        testObjet.y=j;
                                        boolOk=0;
                                        xObjet++;
                                        i++;
                                        if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                        if (i>=40)
                                        {
                                            xObjet=0, yObjet=0;
                                            i=testObjet.x;
                                            j=testObjet.y;
                                            i++;
                                            boolExploree[testObjet.x][testObjet.y]=1;
                                            if (i>=40) i=0, j++;
                                            testObjet.x=i;
                                            testObjet.y=j;
                                        }
                                    }
                                    else if (boolCaseCataPrise[i][j]!=0)
                                    {
                                        xObjet=0, yObjet=0;
                                        i=testObjet.x;
                                        j=testObjet.y;
                                        i++;
                                        boolExploree[testObjet.x][testObjet.y]=1;
                                        if (i>=40) i=0, j++;
                                        testObjet.x=i;
                                        testObjet.y=j;
                                    }
                                    else if (boolCaseCataPrise[i][j]==0)
                                    {
                                        if (boolOk==0)
                                        {
                                            xObjet++;
                                            i++;
                                            if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                            if (xObjet==nbPixelXObjet/16 && yObjet==nbPixelYObjet/16) j=30;
                                            if (i>=40)
                                            {
                                                xObjet=0, yObjet=0;
                                                i=testObjet.x;
                                                j=testObjet.y;
                                                i++;
                                                boolExploree[testObjet.x][testObjet.y]=1;
                                                if (i>=40) i=0, j++;
                                                testObjet.x=i;
                                                testObjet.y=j;
                                            }
                                        }
                                    }
                                }
                                if (j<=testObjet.y+nbPixelYObjet/16)
                                {
                                    for (i=0 ; i<40 ; i++)
                                    {
                                        for (j=0 ; j<30 ; j++)
                                        {
                                            boolExploree[i][j]=1;
                                        }
                                    }
                                }
                                boolOk=1;
                                for (i=0 ; i<40 ; i++)
                                {
                                    for (j=0 ; j<30 ; j++)
                                    {
                                        if (boolExploree[i][j])
                                            boolExploree[i][j]=0;
                                        else
                                            boolOk=0;
                                    }
                                }
                                xObjet=0, yObjet=0;
                                if (boolOk)
                                    indicePremierePage[page+1]=objetACharger, objetACharger=nbObjets;
                                else
                                {
                                    for (i=testObjet.y ; i<nbPixelYObjet/16+testObjet.y ; i++)
                                    {
                                        for (j=testObjet.x ; j<nbPixelXObjet/16+testObjet.x ; j++)
                                        {
                                            carteCatalogue[j][i]=carteObjet[xObjet][yObjet];
                                            airCatalogue[j][i]=airObjet[xObjet][yObjet];
                                            xObjet++;
                                            if (xObjet>=nbPixelXObjet/16) xObjet=0, yObjet++;
                                            boolCaseCataPrise[j][i]=objetACharger;
                                        }
                                    }
                                }
                                xObjet=0, yObjet=0;
                            }
                        }
                        if (boolImages && imagesMotifs!=0 && versions==0)
                            imagesMotifs=0, positionImages.y=0;
                        if (boolImages && imagesMotifs!=0 && versions==1)
                            imagesMotifs--, positionImages.y=0;
                        break;
                    case SDLK_UP:
                        if (!boolContenu && !boolInterdiction)
                        {
                            if (boolCtrl==1 && !boolObjets)
                            {
                                if (phg[1]-16>=0)
                                    phg[1]-=16;
                            }
                        }
                        if (boolImages && positionImages.y!=0)
                            positionImages.y+=16;
                        break;
                    case SDLK_DOWN:
                        if (!boolContenu && !boolInterdiction)
                        {
                            if (boolCtrl==1 && !boolObjets)
                            {
                                if (phg[1]+(401)<=nbPixelY)
                                    phg[1]+=16;
                            }
                        }
                        if (boolImages && positionImages.y!=-160 && imagesMotifs==0 && versions==0)
                            positionImages.y-=16;
                        break;
                    case SDLK_PAGEDOWN:
                        if (!boolContenu && !boolInterdiction && !boolObjets)
                        {
                            if (mapActuelle<nbMaps)
                            {
                                phgx[mapActuelle]=phg[0];
                                phgy[mapActuelle]=phg[1];
                                mapActuelle++;
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carte[i][j]=0;
                                        air[i][j]=0;
                                        contenu[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        mur[i][j]=0;
                                    }
                                }
                                if (!loadMap(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifsAeriens, &nbContenu, mapActuelle))
                                    exit(EXIT_FAILURE);
                                phg[0]=phgx[mapActuelle], phg[1]=phgy[mapActuelle];
                            }
                        }
                        else if (!boolContenu && !boolInterdiction && boolObjets)
                        {
                            if (objectActuel<nbObjets)
                            {
                                objectActuel++;
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carteObjet[i][j]=-1;
                                        airObjet[i][j]=0;
                                        contenuObjet[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        murObjet[i][j]=0;
                                    }
                                }
                                if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objectActuel))
                                    exit(EXIT_FAILURE);
                                phg[0]=0, phg[1]=0;
                            }
                        }
                        break;
                    case SDLK_PAGEUP:
                        if (!boolContenu && !boolInterdiction && !boolObjets)
                        {
                            if (mapActuelle!=1)
                            {
                                phgx[mapActuelle]=phg[0];
                                phgy[mapActuelle]=phg[1];
                                mapActuelle--;
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carte[i][j]=0;
                                        air[i][j]=0;
                                        contenu[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        mur[i][j]=0;
                                    }
                                }
                                if (!loadMap(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifsAeriens, &nbContenu, mapActuelle))
                                    exit(EXIT_FAILURE);
                                phg[0]=phgx[mapActuelle], phg[1]=phgy[mapActuelle];
                            }
                        }
                        else if (!boolContenu && !boolInterdiction && boolObjets)
                        {
                            if (objectActuel!=1)
                            {
                                objectActuel--;
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carteObjet[i][j]=-1;
                                        airObjet[i][j]=0;
                                        contenuObjet[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        murObjet[i][j]=0;
                                    }
                                }
                                if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriens, &nbContenuObjet, objectActuel))
                                    exit(EXIT_FAILURE);
                                phg[0]=0, phg[1]=0;
                            }
                        }
                        break;
                    case SDLK_s:
                        if (!boolContenu && !boolInterdiction && !boolObjets)
                        {
                            nbMotifsAeriens=0;
                            nbContenu=0;
                            for (i=0 ; i<nbPixelX/TAILLE_BLOC ; i++) {
                                for (j=0 ; j<nbPixelY/TAILLE_BLOC ; j++) {
                                    if (air[i][j]!=0) nbMotifsAeriens++; } }
                            for (i=0 ; i<nbPixelX/TAILLE_BLOC ; i++) {
                                for (j=0 ; j<nbPixelY/TAILLE_BLOC ; j++) {
                                    if (contenu[i][j]!=0) nbContenu++; } }
                            if (!savMap(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifsAeriens, &nbContenu, mapActuelle))
                                exit(EXIT_FAILURE);
                        }
                        else if (!boolContenu && !boolInterdiction && boolObjets)
                        {
                            nbMotifsObjet=0;
                            nbCollisionsObjet=0;
                            nbMotifsAeriensObjet=0;
                            nbContenuObjet=0;
                            for (i=0 ; i<nbPixelXObjet/TAILLE_BLOC ; i++) {
                                for (j=0 ; j<nbPixelYObjet/TAILLE_BLOC ; j++) {
                                    if (carteObjet[i][j]!=-1) nbMotifsObjet++; } }
                            for (i=0 ; i<nbPixelXObjet/8 ; i++) {
                                for (j=0 ; j<nbPixelYObjet/8 ; j++) {
                                    if (murObjet[i][j]!=0) nbCollisionsObjet++; } }
                            for (i=0 ; i<nbPixelXObjet/TAILLE_BLOC ; i++) {
                                for (j=0 ; j<nbPixelYObjet/TAILLE_BLOC ; j++) {
                                    if (airObjet[i][j]!=0) nbMotifsAeriensObjet++; } }
                            for (i=0 ; i<nbPixelXObjet/TAILLE_BLOC ; i++) {
                                for (j=0 ; j<nbPixelYObjet/TAILLE_BLOC ; j++) {
                                    if (contenuObjet[i][j]!=0) nbContenuObjet++; } }
                            if (!savObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objectActuel))
                                exit(EXIT_FAILURE);
                        }
                        break;
                    case SDLK_F1:
                        if (!boolContenu && !boolInterdiction)
                        {
                            couche=0;
                            positionCadre.x=(xSouris-phg[0])/16, positionCadre.y=(ySouris-phg[1])/16;
                            if (ySouris==-1) positionCadre.x=-1, positionCadre.y=-1;
                        }
                        break;
                    case SDLK_F2:
                        if (!boolContenu && !boolInterdiction)
                        {
                            couche=1, boolCochee=0;
                            positionCadre.x=(xSouris-phg[0])/8, positionCadre.y=(ySouris-phg[1])/8;
                            if (ySouris==-1) positionCadre.x=-1, positionCadre.y=-1;
                        }
                        break;
                    case SDLK_F3:
                        if (!boolContenu && !boolInterdiction)
                        {
                            couche=2, boolCochee=1;
                            positionCadre.x=(xSouris-phg[0])/16, positionCadre.y=(ySouris-phg[1])/16;
                            if (ySouris==-1) positionCadre.x=-1, positionCadre.y=-1;
                        }
                        break;
                    case SDLK_F4:
                        if (!boolContenu && !boolInterdiction)
                        {
                            couche=3, boolCochee=0;
                            positionCadre.x=(xSouris-phg[0])/16, positionCadre.y=(ySouris-phg[1])/16;
                            if (ySouris==-1) positionCadre.x=-1, positionCadre.y=-1;
                        }
                        break;
                    case SDLK_F5:
                        if (!boolContenu && !boolInterdiction)
                        {
                            couche=4, boolCochee=0;
                            positionCadre.x=(xSouris-phg[0])/16, positionCadre.y=(ySouris-phg[1])/16;
                            if (ySouris==-1) positionCadre.x=-1, positionCadre.y=-1;
                        }
                        break;
                    case SDLK_F6:
                        if (!boolContenu && !boolInterdiction)
                            if (boolCochee) boolCochee=0; else boolCochee=1;
                        break;
                    case SDLK_F7:
                        couche=5;
                        if (!boolObjets)
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    murObjet[i][j]=0;
                                }
                            }
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objetEnCours))
                                exit(EXIT_FAILURE);
                            /*fprintf(stderr, "nbMotifsObjet=%ld\n", nbMotifsObjet);
                            for (i=0 ; i<nbPixelXObjet/16 ; i++)
                            {
                                for (j=0 ; j<nbPixelYObjet/16 ; j++)
                                {
                                    fprintf(stderr, "carteObjet[%ld][%ld]=%ld\n", i, j, carteObjet[i][j]);
                                }
                            }*/
                        }
                        else if (boolObjets)
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carte[i][j]=-1;
                                    air[i][j]=0;
                                    contenu[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    mur[i][j]=0;
                                }
                            }
                            if (!loadObject(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifs, &nbCollisions, &nbMotifsAeriens, &nbContenu, objetEnCours))
                            exit(EXIT_FAILURE);
                        }
                        break;
                    case SDLK_F8:
                        ancienPhg2[0]=phg[0], ancienPhg2[1]=phg[1];
                        phg[0]=0, phg[1]=0;
                        boolCatalogue=1;
                        boolInterdiction=1;
                        for (i=0 ; i<40 ; i++)
                        {
                            for (j=0 ; j<30 ; j++)
                            {
                                carteCatalogue[i][j]=-1;
                                airCatalogue[i][j]=-1;
                                boolCaseCataPrise[i][j]=0;
                                boolExploree[i][j]=0;
                            }
                        }
                        for (objetACharger=indicePremierePage[page] ; objetACharger<=nbObjets ; objetACharger++)
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    murObjet[i][j]=0;
                                }
                            }
                            testObjet.x=0, testObjet.y=0;
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriens, &nbContenuObjet, objetACharger))
                                exit(EXIT_FAILURE);

                            i=0, j=0;

                            while (j<30)
                            {
                                if (xObjet==0 && yObjet==0 && boolCaseCataPrise[i][j]==0)
                                {
                                    testObjet.x=i;
                                    testObjet.y=j;
                                    boolOk=0;
                                    xObjet++;
                                    i++;
                                    if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                    if (i>=40)
                                    {
                                        xObjet=0, yObjet=0;
                                        i=testObjet.x;
                                        j=testObjet.y;
                                        i++;
                                        boolExploree[testObjet.x][testObjet.y]=1;
                                        if (i>=40) i=0, j++;
                                        testObjet.x=i;
                                        testObjet.y=j;
                                    }
                                }
                                else if (boolCaseCataPrise[i][j]!=0)
                                {
                                    xObjet=0, yObjet=0;
                                    i=testObjet.x;
                                    j=testObjet.y;
                                    i++;
                                    boolExploree[testObjet.x][testObjet.y]=1;
                                    if (i>=40) i=0, j++;
                                    testObjet.x=i;
                                    testObjet.y=j;
                                }
                                else if (boolCaseCataPrise[i][j]==0)
                                {
                                    if (boolOk==0)
                                    {
                                        xObjet++;
                                        i++;
                                        if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                        if (xObjet==nbPixelXObjet/16 && yObjet==nbPixelYObjet/16) j=30;
                                        if (i>=40)
                                        {
                                            xObjet=0, yObjet=0;
                                            i=testObjet.x;
                                            j=testObjet.y;
                                            i++;
                                            boolExploree[testObjet.x][testObjet.y]=1;
                                            if (i>=40) i=0, j++;
                                            testObjet.x=i;
                                            testObjet.y=j;
                                        }
                                    }
                                }
                            }
                            if (j<=testObjet.y+nbPixelYObjet/16)
                            {
                                for (i=0 ; i<40 ; i++)
                                {
                                    for (j=0 ; j<30 ; j++)
                                    {
                                        boolExploree[i][j]=1;
                                    }
                                }
                            }
                            boolOk=1;
                            for (i=0 ; i<40 ; i++)
                            {
                                for (j=0 ; j<30 ; j++)
                                {
                                    if (boolExploree[i][j])
                                        boolExploree[i][j]=0;
                                    else
                                        boolOk=0;
                                }
                            }
                            xObjet=0, yObjet=0;
                            if (boolOk)
                                indicePremierePage[page+1]=objetACharger, objetACharger=nbObjets;
                            else
                            {
                                for (i=testObjet.y ; i<nbPixelYObjet/16+testObjet.y ; i++)
                                {
                                    for (j=testObjet.x ; j<nbPixelXObjet/16+testObjet.x ; j++)
                                    {
                                        carteCatalogue[j][i]=carteObjet[xObjet][yObjet];
                                        airCatalogue[j][i]=airObjet[xObjet][yObjet];
                                        xObjet++;
                                        if (xObjet>=nbPixelXObjet/16) xObjet=0, yObjet++;
                                        boolCaseCataPrise[j][i]=objetACharger;
                                    }
                                }
                            }
                            xObjet=0, yObjet=0;
                        }
                        break;
                    case SDLK_0:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='0';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "0", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_1:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='1';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "1", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_2:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='2';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "2", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_3:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='3';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "3", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_4:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='4';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "4", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_5:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='5';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "5", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_6:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='6';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "6", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_7:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='7';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "7", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_8:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='8';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "8", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_9:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='9';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "9", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP0:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='0';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "0", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP1:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='1';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "1", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP2:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='2';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "2", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP3:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='3';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "3", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP4:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='4';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "4", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP5:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='5';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "5", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP6:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='6';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "6", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP7:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='7';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "7", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP8:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='8';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "8", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_KP9:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]='9';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "9", couleur);
                            if (lettreActuel!=3) lettreActuel++;
                        }
                        break;
                    case SDLK_BACKSPACE:
                        if (boolContenu)
                        {
                            numContenu[lettreActuel]=' ';
                            surfaceChiffres[lettreActuel]=TTF_RenderText_Blended(police, "", couleur);
                            if (lettreActuel!=0) lettreActuel--;
                        }
                        break;
                    case SDLK_ESCAPE:
                        continuer=0;
                        break;
                    case SDLK_RETURN:
                        if (!boolCtrl)
                        {
                            if (boolImages) boolImages=0, boolInterdiction=0;
                            else if (boolCatalogue) boolCatalogue=0, boolInterdiction=0, phg[0]=ancienPhg2[0], phg[1]=ancienPhg2[1];
                        }
                        else
                        {
                            if (boolFullScreen) ecran=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE), boolFullScreen=0;
                            else ecran=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_FULLSCREEN), boolFullScreen=1;
                        }
                        break;
                    /*case SDLK_END:
                        if (couche==0)
                            verserLePot(objetActuel, carte[event.motion.x][event.motion.y], event.motion.x, event.motion.y, event.motion.x, event.motion.y, couche, carte, mur, air);
                        else if (couche==1)
                            verserLePot(collisionActuel, mur[event.motion.x][event.motion.y], event.motion.x, event.motion.y, event.motion.x, event.motion.y, couche, carte, mur, air);
                        else if (couche==2)
                            verserLePot(collisionActuel, air[event.motion.x][event.motion.y], event.motion.x, event.motion.y, event.motion.x, event.motion.y, couche, carte, mur, air);
                        break;*/
                    case SDLK_u:
                        if (!boolContenu || !boolInterdiction)
                        {
                            if (whenCouche==0 || whenCouche==2 || whenCouche==3)
                            {
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        //fprintf(stderr, "undoMatrice[%ld][%ld]=%ld\n", i, j, undoMatrice[i][j]);
                                        if (couche==0 && !boolObjets) carte[i][j]=undoMatrice[i][j];
                                        if (couche==0 && boolObjets) carteObjet[i][j]=undoMatrice[i][j];
                                        if (couche==2 && !boolObjets) air[i][j]=undoMatrice[i][j];
                                        if (couche==2 && boolObjets) airObjet[i][j]=undoMatrice[i][j];
                                        if (couche==3 && !boolObjets) contenu[i][j]=undoMatrice[i][j];
                                        if (couche==3 && boolObjets) contenuObjet[i][j]=undoMatrice[i][j];
                                    }
                                }
                            }
                            else if (whenCouche==1)
                            {
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        if (!boolObjets) mur[i][j]=undoMatrice[i][j];
                                        if (boolObjets) murObjet[i][j]=undoMatrice[i][j];
                                    }
                                }
                            }
                        }
                        break;
                    case SDLK_m:
                        if (boolCtrl)
                            boolInterdiction=1, boolImages=1;
                        break;
                    case SDLK_SEMICOLON:
                        if (boolCtrl)
                            boolInterdiction=1, boolImages=1;
                        break;
                }
                break;
            case SDL_KEYUP:
                switch(event.key.keysym.sym)
                {
                    case SDLK_LSHIFT : case SDLK_RSHIFT :
                        if (boolCapsLock==0)
                            boolMaj=0;
                        break;
                    case SDLK_LCTRL : case SDLK_RCTRL :
                        boolCtrl=0;
                        break;
                }
                break;
            case SDL_MOUSEBUTTONDOWN:
                //fprintf(stderr, "event.button.x=%ld event.button.y=%ld\n", event.button.x, event.button.y);
                whenCouche=couche;
                if (couche==0 || couche==2 || couche==3)
                {
                    for (i=0 ; i<400 ; i++)
                    {
                        for (j=0 ; j<400 ; j++)
                        {
                            if (couche==0 && !boolObjets) undoMatrice[i][j]=carte[i][j];
                            if (couche==0 && boolObjets) undoMatrice[i][j]=carteObjet[i][j];
                            if (couche==2 && !boolObjets) undoMatrice[i][j]=air[i][j];
                            if (couche==2 && boolObjets) undoMatrice[i][j]=airObjet[i][j];
                            if (couche==3 && !boolObjets) undoMatrice[i][j]=contenu[i][j];
                            if (couche==3 && boolObjets) undoMatrice[i][j]=contenuObjet[i][j];
                        }
                    }
                }
                else if (couche==1)
                {
                    for (i=0 ; i<800 ; i++)
                    {
                        for (j=0 ; j<800 ; j++)
                        {
                            if (!boolObjets) undoMatrice[i][j]=mur[i][j];
                            if (boolObjets) undoMatrice[i][j]=murObjet[i][j];
                        }
                    }
                }
                if (event.button.button==SDL_BUTTON_LEFT && event.button.y-LONGUEUR_HAUT>-1 && event.button.y<446 && boolMaj)
                {
                    if (couche!=1)
                    {
                        positionVLPx=(phg[0]+event.button.x)/16;
                        positionVLPy=((phg[1]+event.button.y-LONGUEUR_HAUT)/16);
                    }
                    else if (couche==1)
                    {
                        positionVLPx=(phg[0]+event.button.x)/8;
                        positionVLPy=((phg[1]+event.button.y-LONGUEUR_HAUT)/8);
                    }
                    //fprintf(stderr, "Nombre=%ld event.button.x=%ld event.button.y=%ld\n", carte[event.button.x][event.button.y], event.button.x, event.button.y);
                    if (couche==0 && !boolObjets)
                        verserLePot(objetActuel, carte[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carte, mur, air, nbPixelX, nbPixelY, 0);
                    else if (couche==0 && boolObjets)
                        verserLePot(objetActuel, carteObjet[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carteObjet, murObjet, airObjet, nbPixelXObjet, nbPixelYObjet, 0);
                    else if (couche==1 && !boolObjets)
                        verserLePot(collisionActuel, mur[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carte, mur, air, nbPixelX, nbPixelY, 0);
                    else if (couche==1 && boolObjets)
                        verserLePot(collisionActuel, murObjet[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carteObjet, murObjet, airObjet, nbPixelXObjet, nbPixelYObjet, 0);
                    else if (couche==2 && !boolObjets)
                        verserLePot(objetActuel, air[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carte, mur, air, nbPixelX, nbPixelY, 0);
                    else if (couche==2 && boolObjets)
                        verserLePot(objetActuel, airObjet[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carteObjet, murObjet, airObjet, nbPixelXObjet, nbPixelYObjet, 0);
                }
                else if (event.button.button==SDL_BUTTON_RIGHT && event.button.y-LONGUEUR_HAUT>-1 && event.button.y<446 && boolMaj)
                {
                    if (couche==1)
                    {
                        positionVLPx=(phg[0]+event.button.x)/8;
                        positionVLPy=((phg[1]+event.button.y-LONGUEUR_HAUT)/8);
                        //fprintf(stderr, "Nombre=%ld event.button.x=%ld event.button.y=%ld\n", carte[event.button.x][event.button.y], event.button.x, event.button.y);
                        if (couche==1 && !boolObjets)
                            verserLePot(0, mur[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carte, mur, air, nbPixelX, nbPixelY, 0);
                        else if (couche==1 && boolObjets)
                            verserLePot(0, murObjet[positionVLPx][positionVLPy], positionVLPx, positionVLPy, positionVLPx, positionVLPy, couche, carteObjet, murObjet, airObjet, nbPixelXObjet, nbPixelYObjet, 0);
                    }
                }
                else if (event.button.button==SDL_BUTTON_LEFT && event.button.y-LONGUEUR_HAUT>-1 && event.button.y<446)
                {
                    if (couche==0 && !boolContenu && !boolInterdiction)
                    {
                        if (boolObjets)
                            carteObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                        else
                            carte[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                    }
                    else if (couche==1 && !boolContenu && !boolInterdiction)
                    {
                        //if (mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]==0)
                            if (boolObjets)
                                murObjet[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=collisionActuel;
                            else
                                mur[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=collisionActuel;
                        //else if (mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+2][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+2]==0)
                            //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)]=1;
                        //else if (mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+3][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+3]==0)
                            //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=1;
                        //else
                            //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=1;
                    }
                    else if (couche==2 && !boolContenu && !boolInterdiction)
                    {
                        if (boolObjets)
                            airObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                        else
                            air[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                    }
                    else if (couche==3 && !boolContenu && !boolInterdiction)
                        boolContenu2=1, boolContenu=1, whenClic.x=(event.button.x+phg[0])/TAILLE_BLOC, whenClic.y=(event.button.y+phg[1]-LONGUEUR_HAUT)/TAILLE_BLOC;
                    else if (couche==5 && !boolContenu && !boolInterdiction)
                    {
                        for (i=0 ; i<400 ; i++)
                        {
                            for (j=0 ; j<400 ; j++)
                            {
                                if (!boolObjets)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                                else
                                {
                                    carte[i][j]=-1;
                                    air[i][j]=0;
                                    contenu[i][j]=0;
                                }
                            }
                        }
                        for (i=0 ; i<800 ; i++)
                        {
                            for (j=0 ; j<800 ; j++)
                            {
                                if (!boolObjets) murObjet[i][j]=0;
                                else mur[i][j]=0;
                            }
                        }
                        if (!boolObjets)
                        {
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objetEnCours))
                                exit(EXIT_FAILURE);
                        }
                        else
                        {
                            if (!loadObject(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifs, &nbCollisions, &nbMotifsAeriens, &nbContenu, objetEnCours))
                                exit(EXIT_FAILURE);
                        }
                        //fprintf(stderr, "event.button.x=%ld event.button.y=%ld\n", event.button.x, event.button.y);
                        if (!boolObjets)
                        {
                            for (i=0 ; i<nbPixelXObjet/16 ; i++)
                            {
                                for (j=0 ; j<nbPixelYObjet/16 ; j++)
                                {
                                    //fprintf(stderr, "carteObjet[i][j]=%ld\n", carteObjet[i][j]);
                                    if (carteObjet[i][j]!=-1) carte[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=carteObjet[i][j];
                                    if (airObjet[i][j]!=0) air[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=airObjet[i][j];
                                    if (contenuObjet[i][j]!=0) contenu[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=contenuObjet[i][j];
                                }
                            }
                            for (i=0 ; i<nbPixelXObjet/8 ; i++)
                            {
                                for (j=0 ; j<nbPixelYObjet/8 ; j++)
                                {
                                    //fprintf(stderr, "x=%ld y=%ld i=%ld j=%ld\n", i+((phg[0]+event.button.x)/8), j+((phg[1]+event.button.y)/8), i, j);
                                    if ((event.button.x/8)%2==1 && (event.button.y/8)%2==1) mur[(i-1)+((phg[0]+event.button.x)/8)][(j-1)+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                                    else if ((event.button.x/8)%2==0 && (event.button.y/8)%2==1) mur[i+((phg[0]+event.button.x)/8)][(j-1)+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                                    else if ((event.button.x/8)%2==1 && (event.button.y/8)%2==0) mur[(i-1)+((phg[0]+event.button.x)/8)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                                    else mur[i+((phg[0]+event.button.x)/8)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                                }
                            }
                        }
                        else
                        {
                            for (i=0 ; i<nbPixelX/16 ; i++)
                            {
                                for (j=0 ; j<nbPixelY/16 ; j++)
                                {
                                    //fprintf(stderr, "carteObjet[i][j]=%ld\n", carteObjet[i][j]);
                                    if (carte[i][j]!=-1) carteObjet[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=carte[i][j];
                                    if (air[i][j]!=0) airObjet[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=air[i][j];
                                    if (contenu[i][j]!=0) contenuObjet[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=contenu[i][j];
                                }
                            }
                            for (i=0 ; i<nbPixelX/8 ; i++)
                            {
                                for (j=0 ; j<nbPixelY/8 ; j++)
                                {
                                    //fprintf(stderr, "x=%ld y=%ld i=%ld j=%ld\n", i+((phg[0]+event.button.x)/8), j+((phg[1]+event.button.y)/8), i, j);
                                    if ((event.button.x/8)%2==1 && (event.button.y/8)%2==1) murObjet[(i-1)+((phg[0]+event.button.x)/8)][(j-1)+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=mur[i][j];
                                    else if ((event.button.x/8)%2==0 && (event.button.y/8)%2==1) murObjet[i+((phg[0]+event.button.x)/8)][(j-1)+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=mur[i][j];
                                    else if ((event.button.x/8)%2==1 && (event.button.y/8)%2==0) murObjet[(i-1)+((phg[0]+event.button.x)/8)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=mur[i][j];
                                    else murObjet[i+((phg[0]+event.button.x)/8)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=mur[i][j];
                                }
                            }
                        }
                    }
                    if (boolContenu)
                    {
                        if (event.button.x>=217 && event.button.y>=294 && event.button.x<=282 && event.button.y<=318)
                        {
                            if (boolContenu2 && !boolObjets)
                                sscanf(numContenu, "%ld", &contenu[whenClic.x][whenClic.y]);
                            if (boolContenu2 && boolObjets)
                                sscanf(numContenu, "%ld", &contenuObjet[whenClic.x][whenClic.y]);
                            else if (boolEntreTransparence)
                            {
                                sscanf(numContenu, "%ld", &transparence);
                                if (transparence>255) transparence=255;
                                SDL_SetAlpha(fondNoir, SDL_SRCALPHA, transparence);
                            }
                            else if (boolEntrerLargeur)
                            {
                                sscanf(numContenu, "%ld", &largeur);
                                if (!boolObjets) sprintf(ancien, "Ancien : %ld", nbPixelY/16);
                                else if (boolObjets) sprintf(ancien, "Ancien : %ld", nbPixelYObjet/16);
                                surfaceAncien=TTF_RenderText_Blended(police, ancien, couleur);
                                if (largeur>399) largeur=399;
                                boolEntrerLargeur=0,boolEntrerHauteur=1;
                            }
                            else if (boolEntrerHauteur)
                            {
                                sscanf(numContenu, "%ld", &hauteur);
                                if (hauteur>399) hauteur=399;
                                if (!boolReSizeMap)
                                {
                                    if (!boolObjets)
                                    {
                                        nbMaps++;
                                        sprintf(nomMap, "map/carte%ld.map", nbMaps);
                                        nouvelleMap=fopen(nomMap, "w");
                                        fprintf(nouvelleMap, "%ld\n%ld\n", largeur*16, hauteur*16);
                                        for (i=0; i<largeur ; i++){
                                        for (j=0; j<hauteur ; j++){
                                        fprintf(nouvelleMap, "26\n");
                                        fprintf(nouvelleMap, "0\n");
                                        fprintf(nouvelleMap, "0\n");
                                        fprintf(nouvelleMap, "0\n");
                                        fprintf(nouvelleMap, "0\n");
                                        }
                                        }
                                    }
                                    else if (boolObjets)
                                    {
                                        nbObjets++;
                                        sprintf(nomObjet, "object/objet%ld.obj", nbObjets);
                                        nouvelleMap=fopen(nomObjet, "w");
                                        fprintf(nouvelleMap, "%ld\n%ld\n0\n0\n", largeur*16, hauteur*16);
                                    }
                                    fprintf(nouvelleMap, "0\n0\n");
                                    fclose(nouvelleMap);
                                    if (boolImpossibleChargerCarte)
                                    {
                                        for (i=0 ; i<400 ; i++)
                                        {
                                            for (j=0 ; j<400 ; j++)
                                            {
                                                carte[i][j]=0;
                                                air[i][j]=0;
                                                contenu[i][j]=0;
                                            }
                                        }
                                        for (i=0 ; i<800 ; i++)
                                        {
                                            for (j=0 ; j<800 ; j++)
                                            {
                                                mur[i][j]=0;
                                            }
                                        }
                                        if (!loadMap(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifsAeriens, &nbContenu, mapActuelle))
                                            exit(EXIT_FAILURE);
                                    }
                                    else if (boolImpossibleChargerObjet)
                                    {
                                        for (i=0 ; i<400 ; i++)
                                        {
                                            for (j=0 ; j<400 ; j++)
                                            {
                                                carteObjet[i][j]=-1;
                                                airObjet[i][j]=0;
                                                contenuObjet[i][j]=0;
                                            }
                                        }
                                        for (i=0 ; i<800 ; i++)
                                        {
                                            for (j=0 ; j<800 ; j++)
                                            {
                                                murObjet[i][j]=0;
                                            }
                                        }
                                        if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objectActuel))
                                            exit(EXIT_FAILURE);
                                    }
                                }
                                else if(boolReSizeMap)
                                {
                                    if (!boolObjets)
                                    {
                                        nbPixelX=largeur*16;
                                        nbPixelY=hauteur*16;
                                    }
                                    else if (boolObjets)
                                    {
                                        nbPixelXObjet=largeur*16;
                                        nbPixelYObjet=hauteur*16;
                                    }
                                }
                                boolEntrerHauteur=0, boolImpossibleChargerCarte=0, boolImpossibleChargerObjet=0, boolReSizeMap=0;
                            }
                            lettreActuel=0;
                            for (i=0 ; i<4 ; i++)
                            numContenu[i]=' ', surfaceChiffres[i]=NULL;
                            boolContenu=0, boolContenu2=0, boolEntreTransparence=0;
                            if (boolEntrerHauteur) boolContenu=1;
                        }
                        else if (event.button.x>=320 && event.button.y>=294 && event.button.x<=384 && event.button.y<=318)
                        {
                            lettreActuel=0;
                            for (i=0 ; i<4 ; i++)
                                numContenu[i]=' ', surfaceChiffres[i]=NULL;
                            boolContenu=0, boolContenu2=0, boolEntreTransparence=0, boolEntrerLargeur=0, boolEntrerHauteur=0;
                        }
                    }
                    clicGauche=1;
                }
                else if (event.button.y-LONGUEUR_HAUT>-1 && event.button.y<446)
                {
                    if (couche==0 && !boolContenu && !boolInterdiction && !boolObjets)
                        objetActuel=carte[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC];
                    else if (couche==0 && !boolContenu && !boolInterdiction && boolObjets)
                        objetActuel=carteObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC];
                    else if (couche==1 && !boolContenu && !boolInterdiction && !boolObjets)
                    {
                        mur[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=0;
                        //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)]=0;
                        //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=0;
                        //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=0;
                    }
                    else if (couche==1 && !boolContenu && !boolInterdiction && boolObjets)
                        murObjet[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=0;
                    else if (couche==2 && !boolContenu && !boolInterdiction && !boolObjets)
                    {
                        objetActuel=air[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC];
                    }
                    else if (couche==2 && !boolContenu && !boolInterdiction && boolObjets)
                        objetActuel=airObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC];
                    else if (couche==3 && !boolContenu && !boolInterdiction && !boolObjets)
                        contenu[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=0;
                    else if (couche==3 && !boolContenu && !boolInterdiction && boolObjets)
                        contenuObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=0;
                    clicDroit=1;
                    /*if (couche==0)
                        verserLePot(1, carte[(event.button.x+phg[0])/TAILLE_BLOC][(event.button.y+phg[1])/TAILLE_BLOC], (event.button.x+phg[0])/TAILLE_BLOC, (event.button.y+phg[1])/TAILLE_BLOC, (event.button.x+phg[0])/TAILLE_BLOC, (event.button.y+phg[1])/TAILLE_BLOC, couche, carte, mur, air);
                    else if (couche==1)
                        verserLePot(collisionActuel, carte[(event.button.x+phg[0])/TAILLE_BLOC][(event.button.y+phg[1])/TAILLE_BLOC], (event.button.x+phg[0])/TAILLE_BLOC, (event.button.y+phg[1])/TAILLE_BLOC, (event.button.x+phg[0])/TAILLE_BLOC, (event.button.y+phg[1])/TAILLE_BLOC, couche, carte, mur, air);
                    else if (couche==1)
                        verserLePot(objetActuel, carte[(event.button.x+phg[0])/TAILLE_BLOC][(event.button.y+phg[1])/TAILLE_BLOC], (event.button.x+phg[0])/TAILLE_BLOC, (event.button.y+phg[1])/TAILLE_BLOC, (event.button.x+phg[0])/TAILLE_BLOC, (event.button.y+phg[1])/TAILLE_BLOC, couche, carte, mur, air);*/
                }
                if (event.button.button==SDL_BUTTON_LEFT && !boolContenu && !boolImages)
                {
                    if (event.button.x>=38 && event.button.x<=38+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        couche=0;
                    else if (event.button.x>=79 && event.button.x<=79+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        couche=1, boolCochee=0;
                    else if (event.button.x>=124 && event.button.x<=124+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        couche=2, boolCochee=1;
                    else if (event.button.x>=170 && event.button.x<=170+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        couche=3, boolCochee=0;
                    else if (event.button.x>=209 && event.button.x<=209+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        couche=4, boolCochee=0;
                    else if (event.button.x>=250 && event.button.x<=250+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        if (boolCochee) boolCochee=0; else boolCochee=1;
                    else if (event.button.x>=291 && event.button.x<=291+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    {
                        sprintf(numContenu, "%ld", transparence);
                        sprintf(ancien, "Ancien : %ld", transparence);
                        surfaceAncien=TTF_RenderText_Blended(police, ancien, couleur);
                        //if (numContenu[3]=='0' || numContenu[3]=='1' || numContenu[3]=='2' || numContenu[3]=='3' || numContenu[3]=='4' || numContenu[3]=='5' || numContenu[3]=='6' || numContenu[3]=='7' || numContenu[3]=='8' || numContenu[3]=='9') lettreActuel=3;
                        /*if (numContenu[2]=='0' || numContenu[2]=='1' || numContenu[2]=='2' || numContenu[2]=='2' || numContenu[2]=='4' || numContenu[2]=='5' || numContenu[2]=='6' || numContenu[2]=='7' || numContenu[2]=='8' || numContenu[2]=='9') lettreActuel=3;
                        else if (numContenu[1]=='0' || numContenu[1]=='1' || numContenu[1]=='2' || numContenu[1]=='3' || numContenu[1]=='4' || numContenu[1]=='5' || numContenu[1]=='6' || numContenu[1]=='7' || numContenu[1]=='8' || numContenu[1]=='9') lettreActuel=2;
                        else if (numContenu[0]=='0' || numContenu[0]=='1' || numContenu[0]=='2' || numContenu[0]=='3' || numContenu[0]=='4' || numContenu[0]=='5' || numContenu[0]=='6' || numContenu[0]=='7' || numContenu[0]=='8' || numContenu[0]=='9') lettreActuel=1;
                        else lettreActuel=0;*/
                        boolContenu=1, boolEntreTransparence=1;
                    }
                    else if (event.button.x>=332 && event.button.x<=332+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        boolInterdiction=1, boolImages=1;
                    else if (event.button.x>=373 && event.button.x<=373+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        versions=0;
                    else if (event.button.x>=414 && event.button.x<=414+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        versions=1;
                    //else if (event.button.x>=455 && event.button.x<=455+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                        //versions=1;
                    else if (event.button.x>=8 && event.button.x<=26 && event.button.y>=10 && event.button.y<=19 && !boolInterdiction)
                        boolContenu=1, boolEntrerLargeur=1;
                    else if (event.button.x>=496 && event.button.x<=496+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    {
                        if (!boolObjets)
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    murObjet[i][j]=0;
                                }
                            }
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objectActuel))
                                boolImpossibleChargerObjet=1, fprintf(stderr, "Impossible de charger object/objet%ld.obj !\n", objectActuel);
                            boolObjets=1;
                            ancienPhg[0]=phg[0];
                            ancienPhg[1]=phg[1];
                            phg[0]=0, phg[1]=0;
                        }
                        else
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carte[i][j]=0;
                                    air[i][j]=0;
                                    contenu[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    mur[i][j]=0;
                                }
                            }
                            if (!loadMap(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifsAeriens, &nbContenu, mapActuelle))
                                boolImpossibleChargerCarte=1, fprintf(stderr, "Impossible de charger map/carte%ld.map !\n", mapActuelle);
                            boolImpossibleChargerObjet=0;
                            boolObjets=0;
                            phg[0]=ancienPhg[0];
                            phg[1]=ancienPhg[1];
                        }
                        if (couche==5)
                        {
                            if (!boolObjets)
                            {
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carteObjet[i][j]=-1;
                                        airObjet[i][j]=0;
                                        contenuObjet[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        murObjet[i][j]=0;
                                    }
                                }
                                if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objetEnCours))
                                    exit(EXIT_FAILURE);
                            }
                            else if (boolObjets)
                            {
                                for (i=0 ; i<400 ; i++)
                                {
                                    for (j=0 ; j<400 ; j++)
                                    {
                                        carte[i][j]=-1;
                                        air[i][j]=0;
                                        contenu[i][j]=0;
                                    }
                                }
                                for (i=0 ; i<800 ; i++)
                                {
                                    for (j=0 ; j<800 ; j++)
                                    {
                                        mur[i][j]=0;
                                    }
                                }
                                if (!loadObject(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifs, &nbCollisions, &nbMotifsAeriens, &nbContenu, objetEnCours))
                                    exit(EXIT_FAILURE);
                            }
                        }
                    }
                    else if (event.button.x>=537 && event.button.x<=537+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    {
                        couche=5, boolCochee=0;
                        if (!boolObjets)
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    murObjet[i][j]=0;
                                }
                            }
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objetEnCours))
                                exit(EXIT_FAILURE);
                        }
                        else if (boolObjets)
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carte[i][j]=-1;
                                    air[i][j]=0;
                                    contenu[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    mur[i][j]=0;
                                }
                            }
                            if (!loadObject(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifs, &nbCollisions, &nbMotifsAeriens, &nbContenu, objetEnCours))
                                exit(EXIT_FAILURE);
                        }
                    }
                    else if (event.button.x>=579 && event.button.x<=579+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    {
                        ancienPhg2[0]=phg[0], ancienPhg2[1]=phg[1];
                        phg[0]=0, phg[1]=0;
                        boolCatalogue=1;
                        boolInterdiction=1;
                        for (i=0 ; i<40 ; i++)
                        {
                            for (j=0 ; j<30 ; j++)
                            {
                                carteCatalogue[i][j]=-1;
                                airCatalogue[i][j]=-1;
                                boolCaseCataPrise[i][j]=0;
                                boolExploree[i][j]=0;
                            }
                        }
                        for (objetACharger=indicePremierePage[page] ; objetACharger<=nbObjets ; objetACharger++)
                        {
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    murObjet[i][j]=0;
                                }
                            }
                            testObjet.x=0, testObjet.y=0;
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriens, &nbContenuObjet, objetACharger))
                                exit(EXIT_FAILURE);

                            i=0, j=0;

                            while (j<30)
                            {
                                if (xObjet==0 && yObjet==0 && boolCaseCataPrise[i][j]==0)
                                {
                                    testObjet.x=i;
                                    testObjet.y=j;
                                    boolOk=0;
                                    xObjet++;
                                    i++;
                                    if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                    if (i>=40)
                                    {
                                        xObjet=0, yObjet=0;
                                        i=testObjet.x;
                                        j=testObjet.y;
                                        i++;
                                        boolExploree[testObjet.x][testObjet.y]=1;
                                        if (i>=40) i=0, j++;
                                        testObjet.x=i;
                                        testObjet.y=j;
                                    }
                                }
                                else if (boolCaseCataPrise[i][j]!=0)
                                {
                                    xObjet=0, yObjet=0;
                                    i=testObjet.x;
                                    j=testObjet.y;
                                    i++;
                                    boolExploree[testObjet.x][testObjet.y]=1;
                                    if (i>=40) i=0, j++;
                                    testObjet.x=i;
                                    testObjet.y=j;
                                }
                                else if (boolCaseCataPrise[i][j]==0)
                                {
                                    if (boolOk==0)
                                    {
                                        xObjet++;
                                        i++;
                                        if (xObjet==nbPixelXObjet/16) xObjet=0, yObjet++, i-=nbPixelXObjet/16, j++;
                                        if (xObjet==nbPixelXObjet/16 && yObjet==nbPixelYObjet/16) j=30;
                                        if (i>=40)
                                        {
                                            xObjet=0, yObjet=0;
                                            i=testObjet.x;
                                            j=testObjet.y;
                                            i++;
                                            boolExploree[testObjet.x][testObjet.y]=1;
                                            if (i>=40) i=0, j++;
                                            testObjet.x=i;
                                            testObjet.y=j;
                                        }
                                    }
                                }
                            }
                            if (j<=testObjet.y+nbPixelYObjet/16)
                            {
                                for (i=0 ; i<40 ; i++)
                                {
                                    for (j=0 ; j<30 ; j++)
                                    {
                                        boolExploree[i][j]=1;
                                    }
                                }
                            }
                            boolOk=1;
                            for (i=0 ; i<40 ; i++)
                            {
                                for (j=0 ; j<30 ; j++)
                                {
                                    if (boolExploree[i][j])
                                        boolExploree[i][j]=0;
                                    else
                                        boolOk=0;
                                }
                            }
                            xObjet=0, yObjet=0;
                            if (boolOk)
                                indicePremierePage[page+1]=objetACharger, objetACharger=nbObjets;
                            else
                            {
                                for (i=testObjet.y ; i<nbPixelYObjet/16+testObjet.y ; i++)
                                {
                                    for (j=testObjet.x ; j<nbPixelXObjet/16+testObjet.x ; j++)
                                    {
                                        carteCatalogue[j][i]=carteObjet[xObjet][yObjet];
                                        airCatalogue[j][i]=airObjet[xObjet][yObjet];
                                        xObjet++;
                                        if (xObjet>=nbPixelXObjet/16) xObjet=0, yObjet++;
                                        boolCaseCataPrise[j][i]=objetACharger;
                                    }
                                }
                            }
                            xObjet=0, yObjet=0;
                        }
                    }
                    else if (event.button.x>=619 && event.button.x<=619+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    {
                        sprintf(numContenu, "%ld", largeur);
                        if (!boolObjets) sprintf(ancien, "Ancien : %ld", nbPixelX/16);
                        else if (boolObjets) sprintf(ancien, "Ancien : %ld", nbPixelXObjet/16);
                        surfaceAncien=TTF_RenderText_Blended(police, ancien, couleur);
                        boolContenu=1, boolEntrerLargeur=1, boolReSizeMap=1;
                    }
                    else if (event.button.x>=311 && event.button.x<=311+16 && event.button.y>=26 && event.button.y<=26+16)
                    {
                        if (boolFullScreen) ecran=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE), boolFullScreen=0;
                        else ecran=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_FULLSCREEN), boolFullScreen=1;
                    }
                    else if (event.button.x>=353 && event.button.x<=353+16 && event.button.y>=26 && event.button.y<=26+16 && !boolInterdiction)
                        boolConfirmation=1, boolInterdiction=1;
                }
                if (boolImages && event.button.button==SDL_BUTTON_LEFT)
                {
                    if (boolImages && versions==0)
                        objetActuel=(((event.button.x-positionImages.x)/TAILLE_BLOC)+(((event.button.y-positionImages.y)/TAILLE_BLOC)*40))+(imagesMotifs*1600);
                    if (boolImages && versions==1)
                        objetActuel=(((event.button.x-positionImages.x)/TAILLE_BLOC)+(((event.button.y-positionImages.y)/TAILLE_BLOC)*40))+(imagesMotifs*1000);
                }
                else if (boolCatalogue && event.button.button==SDL_BUTTON_LEFT)
                {
                    if (boolCaseCataPrise[event.button.x/16][(event.button.y-LONGUEUR_HAUT)/16]!=0)
                    {
                        objetEnCours=boolCaseCataPrise[event.button.x/16][(event.button.y-LONGUEUR_HAUT)/16], boolInterdiction=0, boolCatalogue=0, phg[0]=ancienPhg2[0], phg[1]=ancienPhg2[1];
                        for (i=0 ; i<400 ; i++)
                        {
                            for (j=0 ; j<400 ; j++)
                            {
                                if (!boolObjets)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                                else
                                {
                                    carte[i][j]=-1;
                                    air[i][j]=0;
                                    contenu[i][j]=0;
                                }
                            }
                        }
                        for (i=0 ; i<800 ; i++)
                        {
                            for (j=0 ; j<800 ; j++)
                            {
                                if (!boolObjets) murObjet[i][j]=0;
                                else mur[i][j]=0;
                            }
                        }
                        if (!boolObjets)
                        {
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriens, &nbContenuObjet, objetEnCours))
                                exit(EXIT_FAILURE);
                        }
                        else
                        {
                            if (!loadObject(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifs, &nbCollisions, &nbMotifsAeriens, &nbContenu, objetEnCours))
                                exit(EXIT_FAILURE);
                        }
                    }
                }
                else if (boolConfirmation && event.button.button==SDL_BUTTON_LEFT)
                {
                    if (event.button.x>=200+58 && event.button.x<=200+107 && event.button.y>=130+41 && event.button.y<=130+56)
                    {
                        if (!boolObjets)
                        {
                            sprintf(ecrireChar, "map/carte%ld.map", mapActuelle);
                            remove(ecrireChar);
                            nbMaps--;
                            for (i=mapActuelle+1 ; i<nbMaps ; i++)
                            {
                                sprintf(ecrireChar, "map/carte%ld.map", i);
                                sprintf(ecrireChar2, "map/carte%ld.map", i-1);
                                rename(ecrireChar, ecrireChar2);
                            }
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carte[i][j]=0;
                                    air[i][j]=0;
                                    contenu[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    mur[i][j]=0;
                                }
                            }
                            if (!loadMap(carte, mur, air, contenu, &nbPixelX, &nbPixelY, &nbMotifsAeriens, &nbContenu, mapActuelle))
                                boolImpossibleChargerCarte=1, fprintf(stderr, "Impossible de charger map/carte%ld.map !\n", mapActuelle);
                        }
                        else if (boolObjets)
                        {
                            sprintf(ecrireChar, "object/objet%ld.obj", objetEnCours);
                            remove(ecrireChar);
                            nbObjets--;
                            for (i=objetEnCours+1 ; i<nbObjets ; i++)
                            {
                                sprintf(ecrireChar, "object/objet%ld.obj", i);
                                sprintf(ecrireChar2, "object/objet%ld.obj", i-1);
                                rename(ecrireChar, ecrireChar2);
                            }
                            for (i=0 ; i<400 ; i++)
                            {
                                for (j=0 ; j<400 ; j++)
                                {
                                    carteObjet[i][j]=-1;
                                    airObjet[i][j]=0;
                                    contenuObjet[i][j]=0;
                                }
                            }
                            for (i=0 ; i<800 ; i++)
                            {
                                for (j=0 ; j<800 ; j++)
                                {
                                    murObjet[i][j]=0;
                                }
                            }
                            if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objectActuel))
                                boolImpossibleChargerObjet=1, fprintf(stderr, "Impossible de charger object/objet%ld.obj !\n", objectActuel);
                        }
                        boolConfirmation=0, boolInterdiction=0;
                    }
                    else if (event.button.x>=200+182 && event.button.x<=200+231 && event.button.y>=130+41 && event.button.y<=130+56)
                        boolConfirmation=0, boolInterdiction=0;
                }
                break;
            case SDL_MOUSEBUTTONUP:
                if (event.button.button==SDL_BUTTON_LEFT)
                    clicGauche=0;
                else if(event.button.button==SDL_BUTTON_RIGHT)
                    clicDroit=0;
                break;
            case SDL_MOUSEMOTION:
                if (clicGauche && event.button.y-LONGUEUR_HAUT>-1 && event.button.y<446)
                {
                    if (couche==0 && !boolContenu && !boolInterdiction)
                    {
                        if (boolObjets)
                            carteObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                        else
                            carte[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                    }
                    else if (couche==1 && !boolContenu && !boolInterdiction)
                    {
                        //if (mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]==0)
                            if (boolObjets)
                                murObjet[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=collisionActuel;
                            else
                                mur[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=collisionActuel;
                        //else if (mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+2][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+2]==0)
                            //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)]=1;
                        //else if (mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+3][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+3]==0)
                            //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=1;
                        //else
                            //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=1;
                    }
                    else if (couche==2 && !boolContenu && !boolInterdiction)
                    {
                        if (boolObjets)
                            airObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                        else
                            air[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=objetActuel;
                    }
                    else if (couche==5 && !boolContenu && !boolInterdiction && !boolObjets)
                    {
                        for (i=0 ; i<nbPixelXObjet/16 ; i++)
                        {
                            for (j=0 ; j<nbPixelYObjet/16 ; j++)
                            {
                                carteObjet[i][j]=-1;
                                airObjet[i][j]=0;
                                contenuObjet[i][j]=0;
                            }
                        }
                        for (i=0 ; i<nbPixelXObjet/8 ; i++)
                        {
                            for (j=0 ; j<nbPixelYObjet/8 ; j++)
                            {
                                airObjet[i][j]=0;
                            }
                        }
                        if (!loadObject(carteObjet, murObjet, airObjet, contenuObjet, &nbPixelXObjet, &nbPixelYObjet, &nbMotifsObjet, &nbCollisionsObjet, &nbMotifsAeriensObjet, &nbContenuObjet, objetEnCours))
                            exit(EXIT_FAILURE);
                        //fprintf(stderr, "event.button.x=%ld event.button.y=%ld\n", event.button.x, event.button.y);
                        for (i=0 ; i<nbPixelXObjet/16 ; i++)
                        {
                            for (j=0 ; j<nbPixelYObjet/16 ; j++)
                            {
                                //fprintf(stderr, "carteObjet[i][j]=%ld\n", carteObjet[i][j]);
                                if (carteObjet[i][j]!=-1) carte[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=carteObjet[i][j];
                                if (airObjet[i][j]!=0) air[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=airObjet[i][j];
                                if (contenuObjet[i][j]!=0) contenu[i+((phg[0]+event.button.x)/16)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/16)]=contenuObjet[i][j];
                            }
                        }
                        for (i=0 ; i<nbPixelXObjet/8 ; i++)
                        {
                            for (j=0 ; j<nbPixelYObjet/8 ; j++)
                            {
                                //fprintf(stderr, "x=%ld y=%ld i=%ld j=%ld\n", i+((phg[0]+event.button.x)/8), j+((phg[1]+event.button.y)/8), i, j);
                                if ((event.button.x/8)%2==1 && (event.button.y/8)%2==1) mur[(i-1)+((phg[0]+event.button.x)/8)][(j-1)+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                                else if ((event.button.x/8)%2==0 && (event.button.y/8)%2==1) mur[i+((phg[0]+event.button.x)/8)][(j-1)+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                                else if ((event.button.x/8)%2==1 && (event.button.y/8)%2==0) mur[(i-1)+((phg[0]+event.button.x)/8)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                                else mur[i+((phg[0]+event.button.x)/8)][j+((phg[1]+event.button.y-LONGUEUR_HAUT)/8)]=murObjet[i][j];
                            }
                        }
                    }
                }
                if (clicDroit && event.button.y-LONGUEUR_HAUT>-1 && event.button.y<446)
                {
                    if (couche==0 && !boolContenu && !boolInterdiction)
                        objetActuel=carte[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC];
                    else if (couche==1 && !boolContenu && !boolInterdiction)
                    {
                        if (boolObjets)
                                murObjet[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=0;
                            else
                                mur[((event.button.x+phg[0]) / 8)][((event.button.y+phg[1]-LONGUEUR_HAUT) / 8)]=0;
                        //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)]=0;
                        //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=0;
                        //mur[(((event.button.x+phg[0]) / TAILLE_BLOC)*2)+1][(((event.button.y+phg[1]) / TAILLE_BLOC)*2)+1]=0;
                    }
                    else if (couche==2 && !boolContenu && !boolInterdiction && !boolObjets)
                    {
                        objetActuel=air[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC];
                    }
                    else if (couche==2 && !boolContenu && !boolInterdiction && boolObjets)
                        objetActuel=airObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC];
                    else if (couche==3 && !boolContenu && !boolInterdiction && !boolObjets)
                        contenu[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=0;
                    else if (couche==3 && !boolContenu && !boolInterdiction && boolObjets)
                        contenuObjet[(event.button.x+phg[0]) / TAILLE_BLOC][(event.button.y+phg[1]-LONGUEUR_HAUT) / TAILLE_BLOC]=0;
                }
                if (event.button.x>=38 && event.button.x<=38+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=1;
                else if (event.button.x>=79 && event.button.x<=79+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=2;
                else if (event.button.x>=124 && event.button.x<=124+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=3;
                else if (event.button.x>=170 && event.button.x<=170+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=4;
                else if (event.button.x>=209 && event.button.x<=209+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=5;
                else if (event.button.x>=250 && event.button.x<=250+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=6;
                else if (event.button.x>=291 && event.button.x<=291+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=7;
                else if (event.button.x>=332 && event.button.x<=332+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=8;
                else if (event.button.x>=373 && event.button.x<=373+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=9;
                else if (event.button.x>=414 && event.button.x<=414+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=10;
                else if (event.button.x>=455 && event.button.x<=455+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=11;
                else if (event.button.x>=8 && event.button.x<=26 && event.button.y>=10 && event.button.y<=19 && !boolInterdiction)
                    tooltips=18;
                else if (event.button.x>=496 && event.button.x<=496+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=12;
                else if (event.button.x>=537 && event.button.x<=537+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=13;
                else if (event.button.x>=579 && event.button.x<=579+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=14;
                else if (event.button.x>=619 && event.button.x<=619+16 && event.button.y>=6 && event.button.y<=6+16 && !boolInterdiction)
                    tooltips=15;
                else if (event.button.x>=311 && event.button.x<=311+16 && event.button.y>=26 && event.button.y<=26+16)
                    tooltips=16;
                else if (event.button.x>=353 && event.button.x<=353+16 && event.button.y>=26 && event.button.y<=26+16 && !boolInterdiction)
                    tooltips=17;
                else
                    tooltips=0;
            xSouris=event.motion.x+phg[0], ySouris=event.motion.y+phg[1]-LONGUEUR_HAUT;
            if (ySouris-phg[1]<0) ySouris=-1, xSouris=-1;
            else if (ySouris-phg[1]>=400) ySouris=-1, xSouris=-1;
            if (couche!=1)
            {
                positionCadre.x=event.motion.x/16, positionCadre.y=(event.motion.y-LONGUEUR_HAUT)/16;
                if (ySouris==-1) positionCadre.x=-1, positionCadre.y=-1;
            }
            else if (couche==1)
            {
                positionCadre.x=event.motion.x/8, positionCadre.y=(event.motion.y-LONGUEUR_HAUT)/8;
                if (ySouris==-1) positionCadre.x=-1, positionCadre.y=-1;
            }
            souris2.x=event.motion.x, souris2.y=event.motion.y;
            break;
        }
        SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 0, 0, 0));
        SDL_FillRect(fondNoir, NULL, SDL_MapRGB(fondNoir->format, 0, 0, 0));
        SDL_FillRect(blocNoir, NULL, SDL_MapRGB(blocNoir->format, 0, 0, 0));
        while(x<=640)
        {
            while(y<=448)
            {
                if (!boolObjets && !boolCatalogue) val=carte[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];
                else if (boolObjets && !boolCatalogue) val=carteObjet[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];
                else if (boolCatalogue) val=carteCatalogue[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];

                if (x>=nbPixelXObjet && boolObjets && !boolCatalogue || y>=nbPixelYObjet+16 && boolObjets && !boolCatalogue) SDL_BlitSurface(blocNoir, NULL, ecran, &position);
                else if (val==-1)
                {
                    position.x=x, position.y=y+LONGUEUR_HAUT;
                    SDL_BlitSurface(vide, NULL, ecran, &position);
                }
                else if (val!=999)
                {
                    if (versions==0)
                    {
                        image=images[(int)(val/1600)];
                        val=val%1600;
                    }
                    else if (versions==1)
                    {
                        image=imagesOlb[(int)(val/1000)];
                        val=val%1000;
                    }

                    clip.x=(val%40)*16; clip.y=((int)(val/40))*16;
                    if (x==0)clip.x+=phg[0]%TAILLE_BLOC;
                    clip.w=TAILLE_BLOC-(clip.x%TAILLE_BLOC);
                    if (y==0)clip.y+=phg[1]%TAILLE_BLOC;
                    clip.h=TAILLE_BLOC-(clip.y%TAILLE_BLOC);
                    position.x=x, position.y=y+LONGUEUR_HAUT;

                    //if (boolObjets) fprintf(stderr, "x=%ld nbPixelXObjet=%ld y=%ld nbPixelYObjet=%ld\n", x, nbPixelXObjet, y, nbPixelYObjet);
                    if (phg[0]+x>=nbPixelX && !boolObjets || phg[1]+y>=nbPixelY && !boolObjets) SDL_BlitSurface(blocNoir, NULL, ecran, &position);
                    else if (val!=-1) SDL_BlitSurface(image, &clip, ecran, &position);
                    else if (val==-1) SDL_BlitSurface(vide, NULL, ecran, &position);
                }

                y+=clip.h;
            }
            y=0;
            x+=clip.w;
        }
        x=0;
        if (couche==2 && boolCochee) position.x=0, position.y=30, SDL_BlitSurface(fondNoir, NULL, ecran, &position);
        else if (couche!=0 && couche!=1 && couche!=3 && boolCochee) position.x=0, position.y=30, SDL_BlitSurface(fondNoir, NULL, ecran, &position);
        while(x<=640)
        {
            while(y<=446)
            {
                if (!boolObjets && !boolCatalogue) val=air[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];
                else if (boolObjets && !boolCatalogue) val=airObjet[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];
                else if (boolCatalogue) val=airCatalogue[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];
                if (val/1600==1) boolTest=1;

                if (val!=0)
                {
                    if (versions==0)
                    {
                        image2=images[(int)(val/1600)];
                        SDL_SetColorKey(image2, SDL_SRCCOLORKEY, SDL_MapRGB(image2->format, 0,0,255));
                        val=val%1600;
                    }
                    else if (versions==1)
                    {
                        image2=imagesOlb[(int)(val/1000)];
                        SDL_SetColorKey(image2, SDL_SRCCOLORKEY, SDL_MapRGB(image2->format, 0,0,255));
                        val=val%1000;
                    }

                    clip.x=(val%40)*16; clip.y=((int)(val/40))*16;
                    if (x==0)clip.x+=phg[0]%TAILLE_BLOC;
                    clip.w=TAILLE_BLOC-(clip.x%TAILLE_BLOC);
                    if (y==0)clip.y+=phg[1]%TAILLE_BLOC;
                    clip.h=TAILLE_BLOC-(clip.y%TAILLE_BLOC);
                    position.x=x, position.y=y+LONGUEUR_HAUT;

                    if (couche==0) SDL_SetAlpha(image2, SDL_SRCALPHA,  128);
                    SDL_BlitSurface(image2, &clip, ecran, &position);
                    if (couche==0) SDL_SetAlpha(image2, 0,  0);
                    boolTest=0;
                }
                else if (boolTest)
                {
                    if (versions==0)
                    {
                        image2=images[(int)(val/1600)];
                        SDL_SetColorKey(image2, SDL_SRCCOLORKEY, SDL_MapRGB(image2->format, 0,0,255));
                        val=val%1600;
                    }
                    else if (versions==1)
                    {
                        image2=imagesOlb[(int)(val/1000)];
                        SDL_SetColorKey(image2, SDL_SRCCOLORKEY, SDL_MapRGB(image2->format, 0,0,255));
                        val=val%1000;
                    }

                    clip.x=(val%40)*16; clip.y=((int)(val/40))*16;
                    if (x==0)clip.x+=phg[0]%TAILLE_BLOC;
                    clip.w=TAILLE_BLOC-(clip.x%TAILLE_BLOC);
                    if (y==0)clip.y+=phg[1]%TAILLE_BLOC;
                    clip.h=TAILLE_BLOC-(clip.y%TAILLE_BLOC);
                    position.x=x, position.y=y+LONGUEUR_HAUT;

                    if (couche==0) SDL_SetAlpha(image2, SDL_SRCALPHA,  128);
                    SDL_BlitSurface(image2, &clip, ecran, &position);
                    if (couche==0) SDL_SetAlpha(image2, 0,  0);
                    boolTest=0;
                }

                y+=clip.h;
            }
            y=0;
            x+=clip.w;
        }
        x=0;
        if (couche==1 && boolCochee || couche==3 && boolCochee) position.x=0, position.y=30, SDL_BlitSurface(fondNoir, NULL, ecran, &position);
        if (couche==1)
        {
            while(x<=640)
            {
                while(y<=446)
                {
                    if (!boolObjets && !boolCatalogue) val=mur[(((phg[0]+x)-((phg[0]+x)%8))/8)][(((phg[1]+y)-((phg[1]+y)%8))/8) ];
                    else if (boolObjets && !boolCatalogue) val=murObjet[(((phg[0]+x)-((phg[0]+x)%8))/8)][(((phg[1]+y)-((phg[1]+y)%8))/8) ];

                    position.x=x, position.y=y+LONGUEUR_HAUT;

                    if (val==1) SDL_BlitSurface(collisions[0], NULL, ecran, &position);
                    if (val==2) SDL_BlitSurface(collisions[1], NULL, ecran, &position);
                    if (val==3) SDL_BlitSurface(collisions[2], NULL, ecran, &position);
                    if (val==4) SDL_BlitSurface(collisions[3], NULL, ecran, &position);
                    if (val==5) SDL_BlitSurface(collisions[4], NULL, ecran, &position);
                    if (val==6) SDL_BlitSurface(collisions[5], NULL, ecran, &position);
                    if (val==7) SDL_BlitSurface(collisions[6], NULL, ecran, &position);
                    if (val==8) SDL_BlitSurface(collisions[7], NULL, ecran, &position);
                    if (val==9) SDL_BlitSurface(collisions[8], NULL, ecran, &position);
                    if (val==10) SDL_BlitSurface(collisions[9], NULL, ecran, &position);
                    if (val==11) SDL_BlitSurface(collisions[10], NULL, ecran, &position);
                    if (val==12) SDL_BlitSurface(collisions[11], NULL, ecran, &position);
                    if (val==13) SDL_BlitSurface(collisions[12], NULL, ecran, &position);
                    if (val==-1) SDL_BlitSurface(collisions[13], NULL, ecran, &position);

                    y+=8;
                }
                y=0;
                x+=8;
            }
            x=0;
        }
        if (couche==3)
        {
            while(x<=640)
            {
                while(y<=446)
                {
                    if (!boolObjets && !boolCatalogue) val=contenu[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];
                    else if (boolObjets && !boolCatalogue) val=contenuObjet[((phg[0]+x)-((phg[0]+x)%TAILLE_BLOC))/TAILLE_BLOC][((phg[1]+y)-((phg[1]+y)%TAILLE_BLOC))/TAILLE_BLOC ];

                    position.x=x, position.y=y+LONGUEUR_HAUT;

                    if (val!=0) SDL_BlitSurface(teste, NULL, ecran, &position);

                    y+=16;
                }
                y=0;
                x+=16;
            }
        x=0;
        }
        position.x=0, position.y=0;
        if (!boolObjets) SDL_BlitSurface(barreOutil, NULL, ecran, &position);
        else if (boolObjets) SDL_BlitSurface(otherBarreOutil, NULL, ecran, &position);
        position.x=250, position.y=6;
        if (boolCochee) SDL_BlitSurface(caseCochee, NULL, ecran, &position);
        else SDL_BlitSurface(caase, NULL, ecran, &position);
        position.x=0, position.y=446;
        SDL_BlitSurface(barreBas, NULL, ecran, &position);
        if (positionCadre.y>-1 && !boolInterdiction && !boolContenu && couche!=5 && couche!=1) position.x=positionCadre.x*16, position.y=positionCadre.y*16+LONGUEUR_HAUT, SDL_BlitSurface(selectMotif, NULL, ecran, &position);
        else if (positionCadre.y>-1 && !boolInterdiction && !boolContenu && couche==1) position.x=positionCadre.x*8, position.y=positionCadre.y*8+LONGUEUR_HAUT, SDL_BlitSurface(petitcarre, NULL, ecran, &position);
        else if (positionCadre.y>-1 && !boolInterdiction && !boolContenu && couche==5)
        {
            //fprintf(stderr, "ICI boolObjets=%ld\n", boolObjets);
            clip.w=16, clip.h=16;
            /*for (i=0 ; i<nbPixelXObjet/16 ; i++)
            {
                for (j=0 ; j<nbPixelYObjet/16 ; j++)
                {
                    fprintf(stderr, "carteObjet[%ld][%ld]=%ld\n", i, j, carteObjet[i][j]);
                }
            }*/
            if (!boolObjets)
            {
                for (i=0 ; i<nbPixelXObjet/16 ; i++)
                {
                    for (j=0 ; j<nbPixelYObjet/16 ; j++)
                    {
                        position.x=(positionCadre.x+i)*16, position.y=(positionCadre.y+j)*16+LONGUEUR_HAUT;
                        val=carteObjet[i][j];
                        if (versions==0)
                        {
                            image2=images[(int)(val/1600)];
                            val=val%1600;
                        }
                        else if (versions==1)
                        {
                            image2=imagesOlb[(int)(val/1000)];
                            val=val%1000;
                        }
                        clip.x=(val%40)*16; clip.y=((int)(val/40))*16;

                        SDL_SetAlpha(image2, SDL_SRCALPHA,  128);
                        if (position.y+j<446 && val!=-1) SDL_BlitSurface(image2, &clip, ecran, &position);
                        SDL_SetAlpha(image2, SDL_SRCALPHA, 128);
                        val=airObjet[i][j];
                        if (versions==0)
                        {
                            image2=images[(int)(val/1600)];
                            val=val%1600;
                        }
                        else if (versions==1)
                        {
                            image2=imagesOlb[(int)(val/1000)];
                            val=val%1000;
                        }
                        clip.x=(val%40)*16; clip.y=((int)(val/40))*16;

                        if (position.y+j<446 && val!=0) SDL_BlitSurface(image2, &clip, ecran, &position);
                        SDL_SetAlpha(image2, SDL_SRCALPHA, 255);

                        if (i==0 && j==0)
                            clip.x=0, clip.y=0;
                        else if (i==(nbPixelXObjet-16)/16 && j==0)
                            clip.x=32, clip.y=0;
                        else if (j==(nbPixelYObjet-16)/16 && i==0)
                            clip.x=0, clip.y=32;
                        else if (i==(nbPixelXObjet-16)/16 && j==(nbPixelYObjet-16)/16)
                            clip.x=32, clip.y=32;
                        else if (j==0)
                            clip.x=16, clip.y=0;
                        else if (i==0)
                            clip.x=0, clip.y=16;
                        else if (j==(nbPixelYObjet-16)/16)
                            clip.x=16, clip.y=32;
                        else if (i==(nbPixelXObjet-16)/16)
                            clip.x=32, clip.y=16;
                        else
                            clip.x=16, clip.y=16;

                        if ((nbPixelXObjet-16)/16==0)
                        {
                            if (j==0)
                                clip.x=48, clip.y=0;
                            if (j==(nbPixelYObjet-16)/16)
                                clip.x=48, clip.y=32;
                            if (j!=0 && j!=(nbPixelYObjet-16)/16)
                                clip.x=48, clip.y=16;
                        }
                        else if ((nbPixelYObjet-16)/16==0)
                        {
                            if (i==0)
                                clip.x=64, clip.y=0;
                            if (i==(nbPixelXObjet-16)/16)
                                clip.x=96, clip.y=0;
                            if (i!=0 && i!=(nbPixelXObjet-16)/16)
                                clip.x=80, clip.y=0;
                        }

                        if (position.y+j<446) SDL_BlitSurface(grandcarre, &clip, ecran, &position);
                        if ((nbPixelXObjet-16)/16==0 && (nbPixelYObjet-16)/16==0)
                            if (position.y+j<446) SDL_BlitSurface(selectMotif, NULL, ecran, &position);
                    }
                }
            }
            else if (boolObjets)
            {
                for (i=0 ; i<nbPixelX/16 ; i++)
                {
                    for (j=0 ; j<nbPixelY/16 ; j++)
                    {
                        position.x=(positionCadre.x+i)*16, position.y=(positionCadre.y+j)*16+LONGUEUR_HAUT;
                        val=carte[i][j];
                        if (versions==0)
                        {
                            image2=images[(int)(val/1600)];
                            val=val%1600;
                        }
                        else if (versions==1)
                        {
                            image2=imagesOlb[(int)(val/1000)];
                            val=val%1000;
                        }
                        clip.x=(val%40)*16; clip.y=((int)(val/40))*16;

                        SDL_SetAlpha(image2, SDL_SRCALPHA,  128);
                        if (position.y+j<446 && val!=-1) SDL_BlitSurface(image2, &clip, ecran, &position);
                        SDL_SetAlpha(image2, SDL_SRCALPHA, 128);
                        val=air[i][j];
                        if (versions==0)
                        {
                            image2=images[(int)(val/1600)];
                            val=val%1600;
                        }
                        else if (versions==1)
                        {
                            image2=imagesOlb[(int)(val/1000)];
                            val=val%1000;
                        }
                        clip.x=(val%40)*16; clip.y=((int)(val/40))*16;

                        if (position.y+j<446 && val!=0) SDL_BlitSurface(image2, &clip, ecran, &position);
                        SDL_SetAlpha(image2, SDL_SRCALPHA, 255);
                        if (i==0 && j==0)
                            clip.x=0, clip.y=0;
                        else if (i==(nbPixelX-16)/16 && j==0)
                            clip.x=32, clip.y=0;
                        else if (j==(nbPixelY-16)/16 && i==0)
                            clip.x=0, clip.y=32;
                        else if (i==(nbPixelX-16)/16 && j==(nbPixelY-16)/16)
                            clip.x=32, clip.y=32;
                        else if (j==0)
                            clip.x=16, clip.y=0;
                        else if (i==0)
                            clip.x=0, clip.y=16;
                        else if (j==(nbPixelY-16)/16)
                            clip.x=16, clip.y=32;
                        else if (i==(nbPixelX-16)/16)
                            clip.x=32, clip.y=16;
                        else
                            clip.x=16, clip.y=16;

                        if ((nbPixelX-16)/16==0)
                        {
                            if (j==0)
                                clip.x=48, clip.y=0;
                            if (j==(nbPixelY-16)/16)
                                clip.x=48, clip.y=32;
                            if (j!=0 && j!=(nbPixelY-16)/16)
                                clip.x=48, clip.y=16;
                        }
                        else if ((nbPixelY-16)/16==0)
                        {
                            if (i==0)
                                clip.x=64, clip.y=0;
                            if (i==(nbPixelX-16)/16)
                                clip.x=96, clip.y=0;
                            if (i!=0 && i!=(nbPixelX-16)/16)
                                clip.x=80, clip.y=0;
                        }

                        if (position.y+j<446) SDL_BlitSurface(grandcarre, &clip, ecran, &position);
                        if ((nbPixelX-16)/16==0 && (nbPixelY-16)/16==0)
                            if (position.y+j<446) SDL_BlitSurface(selectMotif, NULL, ecran, &position);
                    }
                }
            }
        }
        if (boolImpossibleChargerCarte) position.x=0, position.y=46, SDL_BlitSurface(impossibleChargerCarte, NULL, ecran, &position);
        if (boolImpossibleChargerObjet) position.x=0, position.y=46, SDL_BlitSurface(impossibleChargerObjet, NULL, ecran, &position);
        if (boolContenu2) {
            position.x=200;
            position.y=130;
            SDL_BlitSurface(entreContenu, NULL, ecran, &position);
            for (i=0 ; i<lettreActuel ; i++)
            {
                longueurLettre=0;
                for (j=i-1 ; j>=0 ; j--)
                    longueurLettre+=surfaceChiffres[j]->w+2;
                position.x=265+longueurLettre;
                position.y=223;
                SDL_BlitSurface(surfaceChiffres[i], NULL, ecran, &position);
            }
        }
        if (boolEntreTransparence) {
            position.x=200;
            position.y=130;
            SDL_BlitSurface(entreTransparence, NULL, ecran, &position);
            position.x=240;
            position.y=260;
            SDL_BlitSurface(surfaceAncien, NULL, ecran, &position);
            for (i=0 ; i<lettreActuel ; i++)
            {
                longueurLettre=0;
                for (j=i-1 ; j>=0 ; j--)
                    longueurLettre+=surfaceChiffres[j]->w+2;
                position.x=265+longueurLettre;
                position.y=223;
                SDL_BlitSurface(surfaceChiffres[i], NULL, ecran, &position);
            }
        }
        if (boolEntrerLargeur) {
            position.x=200;
            position.y=130;
            if (!boolObjets) SDL_BlitSurface(entrerLargeur, NULL, ecran, &position);
            if (boolObjets) SDL_BlitSurface(entrerLargeurObjet, NULL, ecran, &position);
            if (boolReSizeMap)
            {
                position.x=240;
                position.y=260;
                SDL_BlitSurface(surfaceAncien, NULL, ecran, &position);
            }
            for (i=0 ; i<lettreActuel ; i++)
            {
                longueurLettre=0;
                for (j=i-1 ; j>=0 ; j--)
                    longueurLettre+=surfaceChiffres[j]->w+2;
                position.x=265+longueurLettre;
                position.y=223;
                SDL_BlitSurface(surfaceChiffres[i], NULL, ecran, &position);
            }
        }
        if (boolConfirmation) {
            position.x=200;
            position.y=130;
            SDL_BlitSurface(confirmation, NULL, ecran, &position);
        }
        if (boolEntrerHauteur) {
            position.x=200;
            position.y=130;
            if (!boolObjets) SDL_BlitSurface(entrerHauteur, NULL, ecran, &position);
            else if (boolObjets) SDL_BlitSurface(entrerHauteurObjet, NULL, ecran, &position);
            if (boolReSizeMap)
            {
                position.x=240;
                position.y=260;
                SDL_BlitSurface(surfaceAncien, NULL, ecran, &position);
            }
            for (i=0 ; i<lettreActuel ; i++)
            {
                longueurLettre=0;
                for (j=i-1 ; j>=0 ; j--)
                    longueurLettre+=surfaceChiffres[j]->w+2;
                position.x=265+longueurLettre;
                position.y=223;
                SDL_BlitSurface(surfaceChiffres[i], NULL, ecran, &position);
            }
        }
        if (boolImages)
        {
            position.x=positionImages.x;
            position.y=positionImages.y;
            if (versions==0)
            {
                if (imagesMotifs==0)
                    SDL_BlitSurface(afficheMotif1, NULL, ecran, &position);
                else if (imagesMotifs==1)
                    SDL_BlitSurface(afficheMotif2, NULL, ecran, &position);
            }
            else if (versions==1)
                SDL_BlitSurface(imagesMotifsOlb[imagesMotifs], NULL, ecran, &position);
            if (versions==0)
            {
                position.x=(((objetActuel%1600)%40)*TAILLE_BLOC)+positionImages.x;
                position.y=(((objetActuel%1600)/40)*TAILLE_BLOC)+positionImages.y;
            }
            else if (versions==1)
            {
                position.x=(((objetActuel%1000)%40)*TAILLE_BLOC)+positionImages.x;
                position.y=(((objetActuel%1000)/40)*TAILLE_BLOC)+positionImages.y;
            }
            if (objetActuel<1600 && imagesMotifs==0 && versions==0 || objetActuel>=1600 && imagesMotifs==1 && versions==0) SDL_BlitSurface(selectMotif, NULL, ecran, &position);
            else if (objetActuel<1000+(1000*imagesMotifs) && objetActuel>=1000*imagesMotifs && imagesMotifs>=0 && imagesMotifs<4 && versions==1 || objetActuel>=4000 && imagesMotifs==4 && versions==1) SDL_BlitSurface(selectMotif, NULL, ecran, &position);
        }
        sprintf(positionSouris, "x %ld y %ld", xSouris/TAILLE_BLOC, ySouris/TAILLE_BLOC);
        texte=TTF_RenderText_Blended(police, positionSouris, couleur2);
        position.x=0;
        position.y=450;
        if (ySouris!=-1) SDL_BlitSurface(texte, NULL, ecran, &position);
        if (!boolObjets) sprintf(positionSouris, "carte : %ld", mapActuelle);
        else if (boolObjets) sprintf(positionSouris, "objet : %ld", objectActuel);
        texte=TTF_RenderText_Blended(police, positionSouris, couleur2);
        position.x=280;
        position.y=450;
        if (ySouris!=-1) SDL_BlitSurface(texte, NULL, ecran, &position);
        sprintf(positionSouris, "page : %ld", page);
        texte=TTF_RenderText_Blended(police, positionSouris, couleur2);
        position.x=100;
        position.y=450;
        if (boolCatalogue) SDL_BlitSurface(texte, NULL, ecran, &position);
        texte=TTF_RenderText_Blended(police, "collision actuelle :", couleur2);
        position.x=100;
        position.y=450;
        if (couche==1 && !boolCatalogue) SDL_BlitSurface(texte, NULL, ecran, &position);
        position.x=265;
        position.y=460;
        if (collisionActuel==1 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[0], NULL, ecran, &position);
        if (collisionActuel==2 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[1], NULL, ecran, &position);
        if (collisionActuel==3 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[2], NULL, ecran, &position);
        if (collisionActuel==4 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[3], NULL, ecran, &position);
        if (collisionActuel==5 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[4], NULL, ecran, &position);
        if (collisionActuel==6 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[5], NULL, ecran, &position);
        if (collisionActuel==7 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[6], NULL, ecran, &position);
        if (collisionActuel==8 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[7], NULL, ecran, &position);
        if (collisionActuel==9 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[8], NULL, ecran, &position);
        if (collisionActuel==10 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[9], NULL, ecran, &position);
        if (collisionActuel==11 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[10], NULL, ecran, &position);
        if (collisionActuel==12 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[11], NULL, ecran, &position);
        if (collisionActuel==13 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[12], NULL, ecran, &position);
        if (collisionActuel==-1 && !boolCatalogue && couche==1) SDL_BlitSurface(collisions[13], NULL, ecran, &position);
        if (!boolObjets) sprintf(positionSouris, "Motif : %ld   Motif arien : %ld", carte[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC], air[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC]);
        else sprintf(positionSouris, "Motif : %ld   Motif arien : %ld", carteObjet[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC], airObjet[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC]);
        texte=TTF_RenderText_Blended(police2, positionSouris, couleur2);
        position.x=380;
        position.y=450;
        SDL_BlitSurface(texte, NULL, ecran, &position);
        if (!boolObjets && couche==1) sprintf(positionSouris, "Contenu : %ld   Collision : %ld", contenu[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC], mur[xSouris/(TAILLE_BLOC/2)][ySouris/(TAILLE_BLOC/2)]);
        else if (boolObjets && couche==1) sprintf(positionSouris, "Contenu : %ld   Collision : %ld", contenuObjet[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC], murObjet[xSouris/(TAILLE_BLOC/2)][ySouris/(TAILLE_BLOC/2)]);
        else if (!boolObjets && couche!=1) sprintf(positionSouris, "Contenu : %ld", contenu[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC]);
        else if (boolObjets && couche!=1) sprintf(positionSouris, "Contenu : %ld", contenuObjet[xSouris/TAILLE_BLOC][ySouris/TAILLE_BLOC]);
        texte=TTF_RenderText_Blended(police2, positionSouris, couleur2);
        position.x=380;
        position.y=460;
        SDL_BlitSurface(texte, NULL, ecran, &position);
        sprintf(positionSouris, "x %ld y %ld", xSouris, ySouris);
        texte=TTF_RenderText_Blended(police, positionSouris, couleur2);
        position.x=510;
        position.y=450;
        if (ySouris!=-1) SDL_BlitSurface(texte, NULL, ecran, &position);
        if (tooltips!=0 && tooltips!=13 && tooltips!=14 && tooltips!=15) position.x=souris2.x+10, position.y=souris2.y+10, SDL_BlitSurface(imgToolTips[tooltips-1], NULL, ecran, &position);
        else if (tooltips==13 || tooltips==14 || tooltips==15) position.x=souris2.x-100, position.y=souris2.y+10, SDL_BlitSurface(imgToolTips[tooltips-1], NULL, ecran, &position);
        SDL_Flip(ecran);
    }
    for (i = 0; i < 400; i++)
        free(carte[i]);
    for (i = 0; i < 800; i++)
        free(mur[i]);
    for (i = 0; i < 400; i++)
        free(air[i]);
    for (i = 0; i < 400; i++)
        free(contenu[i]);
    for (i = 0; i < 400; i++)
        free(carteObjet[i]);
    for (i = 0; i < 800; i++)
        free(murObjet[i]);
    for (i = 0; i < 400; i++)
        free(airObjet[i]);
    for (i = 0; i < 400; i++)
        free(contenuObjet[i]);
    for (i = 0; i < 800; i++)
        free(undoMatrice[i]);
    for (i = 0; i < 41; i++)
        free(carteCatalogue[i]);
    for (i = 0; i < 41; i++)
        free(airCatalogue[i]);
    free(carte), free(mur), free(air), free(contenu), free(carteObjet), free(murObjet), free(airObjet), free(contenuObjet), free(undoMatrice), free(carteCatalogue), free(airCatalogue);
    //SDL_Surface *ecran=NULL, *image=NULL, *images[2]={NULL}, *image2=NULL, *collisions[14]={NULL}, *teste=NULL, *texte=NULL, *entreContenu=NULL, *surfaceChiffres[4]={NULL}, *barreOutil=NULL, *fondNoir=NULL, *caase=NULL,                                                                                                                                                                                                                *caseCochee=NULL, *barreBas=NULL, *entreTransparence=NULL, *surfaceAncien=NULL, *afficheMotif1=NULL, *afficheMotif2=NULL, *selectMotif=NULL, *imagesOlb[5]={NULL}, *imagesMotifsOlb[5]={NULL}, *entrerLargeur=NULL, *entrerHauteur=NULL, *impossibleChargerCarte=NULL, *vide=NULL, *impossibleChargerObjet=NULL, *otherBarreOutil=NULL, *entrerLargeurObjet=NULL, *entrerHauteurObjet=NULL, *blocNoir=NULL;
    for (i=0 ; i<2 ; i++) { SDL_FreeSurface(images[i]); }
    for (i=0 ; i<14; i++) {SDL_FreeSurface(collisions[i]);} SDL_FreeSurface(teste), SDL_FreeSurface(texte), SDL_FreeSurface(entreContenu); for (i=0 ; i<4 ; i++) {SDL_FreeSurface(surfaceChiffres[4]);} SDL_FreeSurface(barreOutil), SDL_FreeSurface(fondNoir), SDL_FreeSurface(caase), SDL_FreeSurface(caseCochee), SDL_FreeSurface(entreTransparence), SDL_FreeSurface(surfaceAncien), SDL_FreeSurface(afficheMotif1), SDL_FreeSurface(afficheMotif2), SDL_FreeSurface(selectMotif); for (i=0 ; i<5 ; i++) {SDL_FreeSurface(imagesOlb[i]), SDL_FreeSurface(imagesMotifsOlb[i]);} SDL_FreeSurface(entrerLargeur), SDL_FreeSurface(entrerHauteur), SDL_FreeSurface(impossibleChargerCarte), SDL_FreeSurface(vide), SDL_FreeSurface(impossibleChargerObjet), SDL_FreeSurface(otherBarreOutil), SDL_FreeSurface(entrerLargeurObjet), SDL_FreeSurface(entrerHauteurObjet), SDL_FreeSurface(blocNoir);
    TTF_CloseFont(police);
    TTF_Quit();
    SDL_Quit();
    exit(EXIT_SUCCESS);
}

void verserLePot(int objet, int ancienObjet, int x, int y, int xPrincipal, int yPrincipal, int couche, short **carte, short **mur, short **air, int nbPixelX, int nbPixelY, int nbFois)
{
    //fprintf(stderr, "ICI nbFois=%ld\n", nbFois);
    //fprintf(stderr, "ICIIIIIIIIIIIII objet=%ld ancienObjet=%ld\n", objet, ancienObjet);
    if (objet!=ancienObjet && nbFois!=21475)
    {
        //if ((x-xPrincipal)*(x-xPrincipal)<400 && (y-yPrincipal)*(y-yPrincipal)<400 && couche==0 || (x-xPrincipal)*(x-xPrincipal)<800 && (y-yPrincipal)*(y-yPrincipal)<800 && couche==1 || (x-xPrincipal)*(x-xPrincipal)<400 && (y-yPrincipal)*(y-yPrincipal)<400 && couche==2)
        //{
            if (carte[x][y]==ancienObjet && couche==0 || mur[x][y]==ancienObjet && couche==1 || air[x][y]==ancienObjet && couche==2)
            {
                mur[186][108]=0;
                if (couche==0) carte[x][y]=objet;
                else if (couche==1) mur[x][y]=objet;
                else if (couche==2) air[x][y]=objet;
                if (y!=0) verserLePot(objet, ancienObjet, x, y-1, xPrincipal, yPrincipal, couche, carte, mur, air, nbPixelX, nbPixelY, nbFois+1);
                if (couche>=0 && couche!=1 && couche<=2 && x+1<nbPixelX/16 || couche==1 && x+1<(nbPixelX*2)/16) verserLePot(objet, ancienObjet, x+1, y, xPrincipal, yPrincipal, couche, carte, mur, air, nbPixelX, nbPixelY, nbFois+1);
                if (x!=0) verserLePot(objet, ancienObjet, x-1, y, xPrincipal, yPrincipal, couche, carte, mur, air, nbPixelX, nbPixelY, nbFois+1);
                if (couche>=0 && couche!=1 && couche<=2 && y+1<nbPixelY/16 || couche==1 && y+1<(nbPixelY*2)/16) verserLePot(objet, ancienObjet, x, y+1, xPrincipal, yPrincipal, couche, carte, mur, air, nbPixelX, nbPixelY, nbFois+1);
            }
        //}
    }
}
